import { computed as g, ref as v, onMounted as Re, onBeforeUnmount as Ye, watch as Ne, openBlock as s, createElementBlock as n, normalizeClass as ue, normalizeStyle as T, renderSlot as p, createBlock as V, createCommentVNode as c, unref as o, createSlots as He, withCtx as w, normalizeProps as H, guardReactiveProps as W, createElementVNode as b, Fragment as M, renderList as X, toDisplayString as _, createTextVNode as Pe, createVNode as We, nextTick as Xe, pushScopeId as qe, popScopeId as Je } from "vue";
import { u as Ke, o as Qe, e as Oe, g as Ze, c as el, b as ll, d as Z, p as D, m as tl, f as C, X as al, w as ol, j as ul, E as sl, i as F, k as y, n as q, t as rl, a as nl, x as il, q as vl, r as cl } from "./index-CaV1s-yZ.js";
import { t as dl, u as hl } from "./useResponsive-NZB-WLRF.js";
import { _ as yl } from "./Title-gUz6GDA3.js";
import { u as fl, U as bl } from "./usePrinter-rvJyT65A.js";
import { D as gl } from "./DataTable-e2fnfjXV.js";
import { _ as pl } from "./Tooltip-DfSM1mNP.js";
import { L as ml } from "./Legend-5cQ0xZjK.js";
import wl from "./vue-ui-skeleton-CvFX_ExX.js";
import kl from "./vue-ui-accordion-CpzGQ63y.js";
import { u as Ae } from "./useNestedProp-tWCzZrLx.js";
import { _ as _l } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Cl = (G) => (qe("data-v-315950a4"), G = G(), Je(), G), xl = ["id"], $l = ["xmlns", "viewBox"], Sl = ["id"], Ll = ["stop-color"], Tl = ["stop-color"], Fl = ["stop-color"], zl = ["id"], Nl = ["id"], Pl = /* @__PURE__ */ Cl(() => /* @__PURE__ */ b("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Ol = ["id"], Al = ["flood-color"], Dl = ["d", "stroke", "filter"], Il = ["cx", "cy", "r", "fill", "filter"], Bl = ["stroke", "d"], Vl = ["d", "fill", "stroke", "stroke-width", "filter"], Ml = ["cx", "cy", "r", "fill", "stroke"], Gl = ["cx", "cy", "r", "fill"], El = ["d", "fill", "onMouseenter", "onClick"], Ul = ["cx", "cy", "r", "fill"], jl = ["x", "y", "fill", "font-size"], Rl = ["x", "y", "fill", "font-size"], Yl = ["x", "y", "fill", "font-size"], Hl = ["x", "y", "fill", "font-size"], Wl = ["filter"], Xl = { key: 0 }, ql = ["x", "y"], Jl = { key: 1 }, Kl = ["cx", "cy", "fill", "filter", "onClick"], Ql = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Zl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], et = { key: 2 }, lt = ["x", "y", "width"], tt = {
  key: 3,
  class: "vue-data-ui-watermark"
}, at = ["onClick"], ot = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, ut = { key: 1 }, st = ["innerHTML"], rt = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(G, { expose: De, emit: se }) {
    const S = G, { vue_ui_donut: Ie } = Ke(), E = g({
      get() {
        return !!S.dataset && S.dataset.length;
      },
      set(l) {
        return l;
      }
    }), U = v(null), re = v(null), ne = v(null), J = v(null), ie = v(0), ve = v(0), ce = v(0);
    Re(() => {
      de();
    }), Ye(() => {
      J.value && J.value.disconnect();
    });
    function de() {
      if (Qe(S.dataset) ? Oe({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : S.dataset.forEach((l, a) => {
        Ze({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          E.value = !1, Oe({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: a
          });
        });
      }), e.value.responsive) {
        const l = dl(() => {
          const { width: a, height: t } = hl({
            chart: U.value,
            title: e.value.style.chart.title.text ? re.value : null,
            legend: e.value.style.chart.legend.show ? ne.value : null
          });
          i.value.width = a, i.value.height = t;
        });
        J.value = new ResizeObserver(l), J.value.observe(U.value.parentNode);
      }
    }
    const x = v(el()), Be = v(null), ee = v(!1), le = v(""), z = v(null), he = v(0);
    function ye() {
      const l = Ae({
        userConfig: S.config,
        defaultConfig: Ie
      });
      return l.theme ? {
        ...Ae({
          userConfig: rl.vue_ui_donut[l.theme] || S.config,
          defaultConfig: l
        }),
        customPalette: nl[l.theme] || D
      } : l;
    }
    const e = g({
      get: () => ye(),
      set: (l) => l
    });
    Ne(() => S.config, (l) => {
      e.value = ye(), de(), ie.value += 1, ve.value += 1, ce.value += 1;
    }, { deep: !0 });
    const { isPrinting: fe, isImaging: be, generatePdf: ge, generateImage: pe } = fl({
      elementId: `donut__${x.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut"
    }), me = g(() => ll(e.value.customPalette)), f = v({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), i = v({
      height: 360,
      width: 512
    }), j = g(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, a = i.value.width * l;
      return a > $.value / 2 ? e.value.style.chart.layout.donut.strokeWidth : a;
    }), P = g(() => S.dataset.map((l, a) => ({
      name: l.name,
      color: Z(l.color) || me.value[a] || D[a] || D[a % D.length],
      value: l.values.reduce((t, u) => t + u, 0),
      absoluteValues: l.values,
      comment: l.comment || ""
    }))), k = v(P.value);
    Ne(() => P.value, (l) => k.value = l);
    function Ve() {
      return P.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const L = v([]), we = v(null), ke = v(null), O = v(!1);
    function _e(l) {
      const a = P.value.find((r, h) => h === l);
      let u = k.value.find((r, h) => h === l).value;
      if (L.value.includes(l)) {
        let h = function() {
          u > r ? (cancelAnimationFrame(we.value), k.value = k.value.map((d, oe) => l === oe ? {
            ...d,
            value: r
          } : d), O.value = !1) : (O.value = !0, u += r * 0.025, k.value = k.value.map((d, oe) => l === oe ? {
            ...d,
            value: u
          } : d), we.value = requestAnimationFrame(h));
        };
        L.value = L.value.filter((d) => d !== l);
        const r = a.value;
        h();
      } else if (L.value.length < P.value.length - 1) {
        let r = function() {
          u < 0.1 ? (cancelAnimationFrame(ke.value), L.value.push(l), k.value = k.value.map((h, d) => l === d ? {
            ...h,
            value: 0
          } : h), O.value = !1) : (O.value = !0, u /= 1.1, k.value = k.value.map((h, d) => l === d ? {
            ...h,
            value: u
          } : h), ke.value = requestAnimationFrame(r));
        };
        r();
      }
      se("selectLegend", I.value.map((r) => ({
        name: r.name,
        color: r.color,
        value: r.value
      })));
    }
    const I = g(() => (k.value.forEach((l, a) => {
      if ([null, void 0].includes(l.values))
        return {
          ...l,
          values: []
        };
    }), k.value.map((l, a) => ({
      ...l,
      seriesIndex: a
    })).filter((l, a) => !L.value.includes(a)))), Ce = g(() => S.dataset.map((l, a) => ({
      name: l.name,
      color: Z(l.color) || me.value[a] || D[a] || D[a % D.length],
      value: (l.values || []).reduce((t, u) => t + u, 0),
      shape: "circle"
    })).map((l, a) => ({
      ...l,
      proportion: l.value / S.dataset.map((t) => (t.values || []).reduce((u, r) => u + r, 0)).reduce((t, u) => t + u, 0),
      opacity: L.value.includes(a) ? 0.5 : 1,
      segregate: () => _e(a),
      isSegregated: L.value.includes(a)
    }))), Me = g(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), $ = g(() => {
      const l = Math.min(i.value.width / 3, i.value.height / 3);
      return l < 55 ? 55 : l;
    }), A = g(() => tl({ series: I.value }, i.value.width / 2, i.value.height / 2, $.value, $.value, 1.99999, 2, 1, 360, 105.25, j.value));
    function B(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function xe(l, a) {
      const t = l.value / Ge(a);
      return isNaN(t) ? 0 : F(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        C({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function Ge(l) {
      return [...l].map((a) => a.value).reduce((a, t) => a + t, 0);
    }
    const m = g(() => I.value.map((l) => l.value).reduce((l, a) => l + a, 0)), $e = g(() => m.value / I.value.length), te = v(null), R = v(!1);
    function Ee({ datapoint: l, relativeIndex: a, seriesIndex: t, show: u = !1 }) {
      te.value = { datapoint: l, seriesIndex: t, config: e.value, series: P.value }, ee.value = u, z.value = a;
      let r = "";
      const h = e.value.style.chart.tooltip.customFormat;
      if (R.value = !1, il(h))
        try {
          const d = h({
            seriesIndex: t,
            datapoint: l,
            series: P.value,
            config: e.value
          });
          typeof d == "string" && (le.value = d, R.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), R.value = !1;
        }
      if (!R.value) {
        if (r += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, r += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (r += `<b>${F(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          C({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: a,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const d = F(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            C({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: a,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? r += `<span>(${d})</span></div>` : r += `<b>${d}%</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (r += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), le.value = `<div>${r}</div>`;
      }
    }
    function ae(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(z.value) && z.value !== l ? `url(#blur_${x.value})` : "";
    }
    const N = g(() => {
      const l = I.value.map((t) => ({
        name: t.name,
        color: t.color
      })), a = I.value.map((t) => t.value);
      return { head: l, body: a };
    });
    function Se() {
      Xe(() => {
        const l = N.value.head.map((u, r) => [[
          u.name
        ], [N.value.body[r]], [isNaN(N.value.body[r] / m.value) ? "-" : N.value.body[r] / m.value * 100]]), a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = vl(a);
        cl({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const K = g(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        C({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: m.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], a = N.value.head.map((r, h) => {
        const d = C({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: N.value.body[h], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: r.color,
            name: r.name
          },
          d,
          isNaN(N.value.body[h] / m.value) ? "-" : (N.value.body[h] / m.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: a,
        config: t
      };
    }), Y = v(!1);
    function Ue(l) {
      Y.value = l, he.value += 1;
    }
    const Le = g(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function je(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((a) => "-").join("");
    }
    function Q(l, a) {
      se("selectDatapoint", { datapoint: l, index: a });
    }
    function Te() {
      f.value.showTable = !f.value.showTable;
    }
    function Fe() {
      f.value.dataLabels.show = !f.value.dataLabels.show;
    }
    function ze() {
      f.value.showTooltip = !f.value.showTooltip;
    }
    return De({
      getData: Ve,
      generatePdf: ge,
      generateCsv: Se,
      generateImage: pe,
      toggleTable: Te,
      toggleLabels: Fe,
      toggleTooltip: ze
    }), (l, a) => (s(), n("div", {
      ref_key: "donutChart",
      ref: U,
      class: ue(`vue-ui-donut ${Y.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: T(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${x.value}`
    }, [
      p(l.$slots, "userConfig", {}, void 0, !0),
      e.value.style.chart.title.text ? (s(), n("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: re,
        style: T(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:24px`)
      }, [
        (s(), V(yl, {
          key: `title_${ie.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : c("", !0),
      e.value.userOptions.show && E.value ? (s(), V(bl, {
        ref_key: "details",
        ref: Be,
        key: `user_option_${he.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: o(fe),
        isImaging: o(be),
        uid: x.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: Y.value,
        chartElement: U.value,
        isTooltip: f.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        onToggleFullscreen: Ue,
        onGeneratePdf: o(ge),
        onGenerateCsv: Se,
        onGenerateImage: o(pe),
        onToggleTable: Te,
        onToggleLabels: Fe,
        onToggleTooltip: ze
      }, He({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: w(() => [
            p(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: w(() => [
            p(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: w(() => [
            p(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: w(() => [
            p(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: w(() => [
            p(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: w(() => [
            p(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: w(({ toggleFullscreen: t, isFullscreen: u }) => [
            p(l.$slots, "optionFullscreen", H(W({ toggleFullscreen: t, isFullscreen: u })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "isTooltip", "titles", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      E.value ? (s(), n("svg", {
        key: 2,
        xmlns: o(al),
        class: ue({ "vue-data-ui-fullscreen--on": Y.value, "vue-data-ui-fulscreen--off": !Y.value }),
        viewBox: `0 0 ${i.value.width <= 0 ? 10 : i.value.width} ${i.value.height <= 0 ? 10 : i.value.height}`,
        style: T(`max-width:100%; overflow: visible; background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        b("defs", null, [
          e.value.style.chart.useGradient ? (s(), n("radialGradient", {
            key: 0,
            id: `gradient_${x.value}`
          }, [
            b("stop", {
              offset: "0%",
              "stop-color": `${o(Z)(e.value.style.chart.backgroundColor)}00`
            }, null, 8, Ll),
            b("stop", {
              offset: "77%",
              "stop-color": "#FFFFFF" + o(ol)[e.value.style.chart.gradientIntensity]
            }, null, 8, Tl),
            b("stop", {
              offset: "100%",
              "stop-color": `${o(Z)(e.value.style.chart.backgroundColor)}00`
            }, null, 8, Fl)
          ], 8, Sl)) : c("", !0)
        ]),
        b("defs", null, [
          b("filter", {
            id: `blur_${x.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            b("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${x.value}`
            }, null, 8, Nl),
            Pl
          ], 8, zl),
          b("filter", {
            id: `shadow_${x.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            b("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Al)
          ], 8, Ol)
        ]),
        (s(!0), n(M, null, X(A.value, (t, u) => (s(), n("g", null, [
          B(t) && f.value.dataLabels.show ? (s(), n("path", {
            key: 0,
            d: o(ul)(t, { x: i.value.width / 2, y: i.value.height / 2 }, 16, 16, !1, !1, j.value),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: ae(u)
          }, null, 8, Dl)) : c("", !0)
        ]))), 256)),
        b("circle", {
          cx: i.value.width / 2,
          cy: i.value.height / 2,
          r: $.value <= 0 ? 10 : $.value,
          fill: e.value.style.chart.backgroundColor,
          filter: e.value.style.chart.layout.donut.useShadow ? `url(#shadow_${x.value})` : ""
        }, null, 8, Il),
        m.value ? (s(), n(M, { key: 0 }, [
          (s(!0), n(M, null, X(A.value, (t, u) => (s(), n("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, Bl))), 256)),
          (s(!0), n(M, null, X(A.value, (t, u) => (s(), n("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: `${t.color}CC`,
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: ae(u)
          }, null, 8, Vl))), 256))
        ], 64)) : (s(), n("circle", {
          key: 1,
          cx: i.value.width / 2,
          cy: i.value.height / 2,
          r: $.value <= 0 ? 10 : $.value,
          fill: e.value.style.chart.backgroundColor,
          stroke: o(sl)(e.value.style.chart.background)
        }, null, 8, Ml)),
        e.value.style.chart.useGradient ? (s(), n("circle", {
          key: 2,
          cx: i.value.width / 2,
          cy: i.value.height / 2,
          r: (
            /* This might require adjustments */
            $.value <= 0 ? 10 : $.value
          ),
          fill: `url(#gradient_${x.value})`
        }, null, 8, Gl)) : c("", !0),
        m.value ? (s(!0), n(M, { key: 3 }, X(A.value, (t, u) => (s(), n("path", {
          "data-cy-donut-trap": "",
          d: t.arcSlice,
          fill: z.value === u ? "rgba(0,0,0,0.1)" : "transparent",
          onMouseenter: (r) => Ee({
            datapoint: t,
            relativeIndex: u,
            seriesIndex: t.seriesIndex,
            show: !0
          }),
          onMouseleave: a[0] || (a[0] = (r) => {
            ee.value = !1, z.value = null;
          }),
          onClick: (r) => Q(t, u)
        }, null, 40, El))), 256)) : c("", !0),
        e.value.style.chart.layout.labels.hollow.show ? (s(), n("circle", {
          key: 4,
          cx: i.value.width / 2,
          cy: i.value.height / 2,
          r: (
            /* This might require adjustments */
            $.value - j.value <= 0 ? 10 : $.value - j.value
          ),
          fill: e.value.style.chart.backgroundColor
        }, null, 8, Ul)) : c("", !0),
        e.value.style.chart.layout.labels.hollow.total.show ? (s(), n("text", {
          key: 5,
          "text-anchor": "middle",
          x: i.value.width / 2,
          y: i.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
          fill: e.value.style.chart.layout.labels.hollow.total.color,
          "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
          style: T(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
        }, _(e.value.style.chart.layout.labels.hollow.total.text), 13, jl)) : c("", !0),
        e.value.style.chart.layout.labels.hollow.total.show ? (s(), n("text", {
          key: 6,
          "text-anchor": "middle",
          x: i.value.width / 2,
          y: i.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
          fill: e.value.style.chart.layout.labels.hollow.total.value.color,
          "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
          style: T(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
        }, _(o(F)(
          e.value.style.chart.layout.labels.hollow.total.value.formatter,
          m.value,
          o(C)({
            p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
            v: m.value,
            s: e.value.style.chart.layout.labels.hollow.total.value.suffix
          })
        )), 13, Rl)) : c("", !0),
        e.value.style.chart.layout.labels.hollow.average.show ? (s(), n("text", {
          key: 7,
          "text-anchor": "middle",
          x: i.value.width / 2,
          y: i.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
          fill: e.value.style.chart.layout.labels.hollow.average.color,
          "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
          style: T(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
        }, _(e.value.style.chart.layout.labels.hollow.average.text), 13, Yl)) : c("", !0),
        e.value.style.chart.layout.labels.hollow.average.show ? (s(), n("text", {
          key: 8,
          "text-anchor": "middle",
          x: i.value.width / 2,
          y: i.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
          fill: e.value.style.chart.layout.labels.hollow.average.value.color,
          "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
          style: T(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
        }, _(O.value ? "--" : o(F)(
          e.value.style.chart.layout.labels.hollow.average.value.formatter,
          $e.value,
          o(C)({
            p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
            v: $e.value,
            s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
            r: e.value.style.chart.layout.labels.hollow.average.value.rounding
          })
        )), 13, Hl)) : c("", !0),
        (s(!0), n(M, null, X(A.value, (t, u) => (s(), n("g", {
          filter: ae(u),
          class: ue({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (s(), n("g", Xl, [
            (s(), n("foreignObject", {
              x: o(y)(t, !0).anchor === "end" ? o(y)(t).x - 120 : o(y)(t, !0).anchor === "middle" ? o(y)(t).x - 60 : o(y)(t).x,
              y: o(q)(t) - (Le.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              b("div", null, [
                p(l.$slots, "dataLabel", H(W({
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(z.value) || z.value === u,
                  isSafari: Le.value,
                  isVisible: B(t) && f.value.dataLabels.show,
                  textAlign: o(y)(t, !0, 16, !0).anchor,
                  flexAlign: o(y)(t, !0, 16).anchor,
                  percentage: xe(t, A.value)
                })), void 0, !0)
              ])
            ], 8, ql))
          ])) : (s(), n("g", Jl, [
            B(t) && f.value.dataLabels.show ? (s(), n("circle", {
              key: 0,
              cx: o(y)(t).x,
              cy: o(q)(t) - 3.5,
              fill: t.color,
              r: 3,
              filter: !e.value.useBlurOnHover || [null, void 0].includes(z.value) || z.value === u ? "" : `url(#blur_${x.value})`,
              onClick: (r) => Q(t, u)
            }, null, 8, Kl)) : c("", !0),
            B(t) && f.value.dataLabels.show ? (s(), n("text", {
              key: 1,
              "text-anchor": o(y)(t, !0, 12).anchor,
              x: o(y)(t, !0, 12).x,
              y: o(q)(t),
              fill: e.value.style.chart.layout.labels.percentage.color,
              "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
              style: T(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
              onClick: (r) => Q(t, u)
            }, _(xe(t, A.value)) + " " + _(e.value.style.chart.layout.labels.value.show ? `(${o(F)(
              e.value.style.chart.layout.labels.value.formatter,
              t.value,
              o(C)({
                p: e.value.style.chart.layout.labels.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.labels.dataLabels.suffix,
                r: e.value.style.chart.layout.labels.value.rounding
              }),
              { datapoint: t }
            )})` : ""), 13, Ql)) : c("", !0),
            B(t) && f.value.dataLabels.show ? (s(), n("text", {
              key: 2,
              "text-anchor": o(y)(t).anchor,
              x: o(y)(t, !0, 12).x,
              y: o(q)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
              fill: e.value.style.chart.layout.labels.name.color,
              "font-size": e.value.style.chart.layout.labels.name.fontSize,
              style: T(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
              onClick: (r) => Q(t, u)
            }, _(t.name), 13, Zl)) : c("", !0)
          ])),
          f.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (s(), n("g", et, [
            B(t) ? (s(), n("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (o(y)(t, !0).anchor === "end" ? o(y)(t).x - e.value.style.chart.comments.width : o(y)(t, !0).anchor === "middle" ? o(y)(t).x - e.value.style.chart.comments.width / 2 : o(y)(t).x),
              y: o(q)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              b("div", null, [
                p(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: o(y)(t, !0, 16, !0).anchor, flexAlign: o(y)(t, !0, 16).anchor }
                }, void 0, !0)
              ])
            ], 8, lt)) : c("", !0)
          ])) : c("", !0)
        ], 10, Wl))), 256)),
        p(l.$slots, "svg", { svg: i.value }, void 0, !0)
      ], 14, $l)) : c("", !0),
      l.$slots.watermark ? (s(), n("div", tt, [
        p(l.$slots, "watermark", H(W({ isPrinting: o(fe) || o(be) })), void 0, !0)
      ])) : c("", !0),
      E.value ? c("", !0) : (s(), V(wl, {
        key: 4,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: j.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      b("div", {
        ref_key: "chartLegend",
        ref: ne
      }, [
        e.value.style.chart.legend.show ? (s(), V(ml, {
          key: `legend_${ce.value}`,
          legendSet: Ce.value,
          config: Me.value,
          onClickMarker: a[1] || (a[1] = ({ i: t }) => _e(t))
        }, {
          item: w(({ legend: t, index: u }) => [
            b("div", {
              onClick: (r) => t.segregate(),
              style: T(`opacity:${L.value.includes(u) ? 0.5 : 1}`)
            }, [
              Pe(_(t.name) + ": " + _(o(F)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                o(C)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: u
                }
              )) + " ", 1),
              L.value.includes(u) ? (s(), n("span", ut, " ( " + _(je(t.proportion * 100)) + " % ) ", 1)) : (s(), n("span", ot, " (" + _(isNaN(t.value / m.value) ? "-" : o(F)(
                e.value.style.chart.layout.labels.percentage.formatter,
                O.value ? t.proportion * 100 : t.value / m.value * 100,
                o(C)({
                  v: O.value ? t.proportion * 100 : t.value / m.value * 100,
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, at)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : c("", !0),
        p(l.$slots, "legend", { legend: Ce.value }, void 0, !0)
      ], 512),
      We(pl, {
        show: f.value.showTooltip && ee.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: U.value,
        content: le.value,
        isCustom: R.value
      }, {
        "tooltip-before": w(() => [
          p(l.$slots, "tooltip-before", H(W({ ...te.value })), void 0, !0)
        ]),
        "tooltip-after": w(() => [
          p(l.$slots, "tooltip-after", H(W({ ...te.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      E.value ? (s(), V(kl, {
        key: 5,
        hideDetails: "",
        config: {
          open: f.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: w(() => [
          (s(), V(gl, {
            key: `table_${ve.value}`,
            colNames: K.value.colNames,
            head: K.value.head,
            body: K.value.body,
            config: K.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[2] || (a[2] = (t) => f.value.showTable = !1)
          }, {
            th: w(({ th: t }) => [
              b("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, st)
            ]),
            td: w(({ td: t }) => [
              Pe(_(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? o(F)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                o(C)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : t : o(F)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                o(C)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, xl));
  }
}, wt = /* @__PURE__ */ _l(rt, [["__scopeId", "data-v-315950a4"]]);
export {
  wt as default
};
