import { toRef as ne, resolveComponent as re, openBlock as s, createElementBlock as r, Fragment as y, renderList as N, withModifiers as M, createBlock as R, createCommentVNode as m, createElementVNode as x, toDisplayString as Se, normalizeStyle as K, createVNode as U, computed as B, onMounted as qe, ref as f, watch as Ze, normalizeClass as we, unref as I, createSlots as Je, withCtx as $, renderSlot as P, normalizeProps as Z, guardReactiveProps as J, createTextVNode as Ke, nextTick as Pe } from "vue";
import { u as Qe, o as _e, e as et, c as Te, t as tt, a as ot, p as Fe, b as lt, X as at, l as st, M as nt, q as rt, r as it, x as ut, y as ct } from "./index-CaV1s-yZ.js";
import { _ as dt } from "./Title-gUz6GDA3.js";
import { u as vt, U as ft } from "./usePrinter-rvJyT65A.js";
import { D as ht } from "./DataTable-e2fnfjXV.js";
import { _ as pt } from "./Tooltip-DfSM1mNP.js";
import W from "./BaseIcon-rwm-10Hu.js";
import gt from "./vue-ui-skeleton-CvFX_ExX.js";
import yt from "./vue-ui-accordion-CpzGQ63y.js";
import { u as Re } from "./useNestedProp-tWCzZrLx.js";
import { _ as mt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const bt = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onClick", "onMouseover"], kt = {
  __name: "RecursiveCircles",
  props: {
    color: {
      type: String,
      default: "#000000"
    },
    dataset: {
      type: Array,
      default: () => []
    },
    hoveredUid: {
      type: String,
      default: null
    },
    linkColor: {
      type: String,
      default: "#CCCCCC"
    },
    stroke: {
      type: String,
      default: "#FFFFFF"
    },
    strokeHovered: {
      type: String,
      default: "#000000"
    }
  },
  emits: ["zoom", "hover"],
  setup(a, { emit: C }) {
    const k = a;
    function c(n) {
      C("zoom", n);
    }
    function d(n) {
      C("hover", n);
    }
    return ne(k, "dataset").value.forEach((n) => {
      n.nodes && n.nodes.length > 0 && n.nodes.forEach((u) => {
        u.ancestor = n;
      });
    }), (n, u) => {
      const T = re("RecursiveCircles", !0);
      return s(!0), r(y, null, N(a.dataset, (h) => (s(), r(y, null, [
        h.polygonPath && h.polygonPath.coordinates ? (s(), r(y, { key: 0 }, [
          (s(!0), r(y, null, N(h.polygonPath.coordinates, (O, H) => (s(), r("circle", {
            cx: O.x,
            cy: O.y,
            r: h.circleRadius,
            fill: `url(#gradient_${h.color})`,
            stroke: a.hoveredUid && a.hoveredUid === h.uid ? a.strokeHovered : a.stroke,
            "stroke-width": a.hoveredUid && a.hoveredUid === h.uid ? h.circleRadius / 6 : h.circleRadius / 12,
            style: { cursor: "pointer" },
            onClick: M((b) => c(h), ["stop"]),
            onMouseover: (b) => d(h),
            onMouseleave: u[0] || (u[0] = (b) => d(null))
          }, null, 40, bt))), 256)),
          h.nodes && h.nodes.length > 0 ? (s(), R(T, {
            key: 0,
            dataset: h.nodes,
            color: a.color,
            stroke: a.stroke,
            strokeHovered: a.strokeHovered,
            hoveredUid: a.hoveredUid,
            onZoom: c,
            onHover: d
          }, null, 8, ["dataset", "color", "stroke", "strokeHovered", "hoveredUid"])) : m("", !0)
        ], 64)) : m("", !0)
      ], 64))), 256);
    };
  }
}, Ct = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], $t = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], xt = {
  __name: "RecursiveLinks",
  props: {
    dataset: {
      type: Array,
      default: () => []
    },
    color: {
      type: String,
      default: "#DDDDDD"
    },
    backgroundColor: {
      type: String,
      default: "#FFFFFF"
    }
  },
  setup(a) {
    return ne(a, "dataset").value.forEach((c) => {
      c.nodes && c.nodes.length > 0 && c.nodes.forEach((d) => {
        d.ancestor = c;
      });
    }), (c, d) => {
      const S = re("RecursiveLinks", !0);
      return s(), r(y, null, [
        (s(!0), r(y, null, N(a.dataset, (n) => (s(), r(y, null, [
          n.polygonPath && n.polygonPath.coordinates ? (s(!0), r(y, { key: 0 }, N(n.polygonPath.coordinates, (u, T) => (s(), r(y, null, [
            n.ancestor && n.ancestor.polygonPath ? (s(), r(y, { key: 0 }, [
              x("line", {
                x1: u.x,
                y1: u.y,
                x2: n.ancestor.polygonPath.coordinates[0].x,
                y2: n.ancestor.polygonPath.coordinates[0].y,
                stroke: a.backgroundColor,
                "stroke-width": n.circleRadius / 1.5
              }, null, 8, Ct),
              x("line", {
                x1: u.x,
                y1: u.y,
                x2: n.ancestor.polygonPath.coordinates[0].x,
                y2: n.ancestor.polygonPath.coordinates[0].y,
                stroke: a.color,
                "stroke-width": n.circleRadius / 2
              }, null, 8, $t)
            ], 64)) : m("", !0)
          ], 64))), 256)) : m("", !0)
        ], 64))), 256)),
        (s(!0), r(y, null, N(a.dataset, (n) => (s(), r(y, null, [
          n.polygonPath && n.polygonPath.coordinates ? (s(), r(y, { key: 0 }, [
            n.nodes && n.nodes.length > 0 ? (s(), R(S, {
              key: 0,
              dataset: n.nodes,
              color: a.color,
              backgroundColor: a.backgroundColor
            }, null, 8, ["dataset", "color", "backgroundColor"])) : m("", !0)
          ], 64)) : m("", !0)
        ], 64))), 256))
      ], 64);
    };
  }
}, wt = ["x", "y", "fill", "font-size"], Pt = {
  __name: "RecursiveLabels",
  props: {
    color: {
      type: String,
      default: "#000000"
    },
    dataset: {
      type: Array,
      default: () => []
    },
    hoveredUid: {
      type: String,
      default: null
    }
  },
  emits: ["zoom", "hover"],
  setup(a, { emit: C }) {
    return ne(a, "dataset").value.forEach((d) => {
      d.nodes && d.nodes.length > 0 && d.nodes.forEach((S) => {
        S.ancestor = d;
      });
    }), (d, S) => {
      const n = re("RecursiveLabels", !0);
      return s(!0), r(y, null, N(a.dataset, (u) => (s(), r(y, null, [
        u.polygonPath && u.polygonPath.coordinates ? (s(), r(y, { key: 0 }, [
          (s(!0), r(y, null, N(u.polygonPath.coordinates, (T) => (s(), r("text", {
            x: T.x,
            y: T.y + u.circleRadius * 2,
            fill: a.color,
            "font-size": u.circleRadius,
            "text-anchor": "middle",
            style: { opacity: "0.8", "pointer-events": "none" }
          }, Se(u.name), 9, wt))), 256)),
          u.nodes && u.nodes.length > 0 ? (s(), R(n, {
            key: 0,
            dataset: u.nodes,
            color: a.color,
            hoveredUid: a.hoveredUid
          }, null, 8, ["dataset", "color", "hoveredUid"])) : m("", !0)
        ], 64)) : m("", !0)
      ], 64))), 256);
    };
  }
}, Tt = { style: { position: "relative", height: "100%", width: "100%" } }, Ft = {
  __name: "BaseDirectionPad",
  props: {
    color: {
      type: String,
      default: "#FF0000"
    },
    isFullscreen: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["moveLeft", "moveTop", "moveRight", "moveBottom", "reset"],
  setup(a, { emit: C }) {
    return (k, c) => (s(), r("div", {
      style: K(`position: ${a.isFullscreen ? "fixed" : "absolute"};bottom:0;right:${a.isFullscreen ? "12px" : "0"};width:80px;height:80px`),
      "data-html2canvas-ignore": ""
    }, [
      x("div", Tt, [
        x("button", {
          onClick: c[0] || (c[0] = M((d) => C("moveLeft"), ["stop"])),
          style: { position: "absolute", left: "0", top: "50%", transform: "translateY(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          U(W, {
            stroke: a.color,
            name: "arrowLeft",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[1] || (c[1] = M((d) => C("moveTop"), ["stop"])),
          style: { position: "absolute", top: "0", left: "50%", transform: "translateX(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          U(W, {
            stroke: a.color,
            name: "arrowTop",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[2] || (c[2] = M((d) => C("moveRight"), ["stop"])),
          style: { position: "absolute", right: "0", top: "50%", transform: "translateY(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          U(W, {
            stroke: a.color,
            name: "arrowRight",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[3] || (c[3] = M((d) => C("moveBottom"), ["stop"])),
          style: { position: "absolute", bottom: "0", left: "50%", transform: "translateX(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          U(W, {
            stroke: a.color,
            name: "arrowBottom",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        x("button", {
          onClick: c[4] || (c[4] = M((d) => C("reset"), ["stop"])),
          style: { position: "absolute", top: "50%", left: "50%", transform: "translate(-50%,-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          U(W, {
            stroke: a.color,
            name: "close",
            style: { cursor: "pointer" },
            strokeWidth: 2
          }, null, 8, ["stroke"])
        ])
      ])
    ], 4));
  }
}, Rt = ["id"], St = ["xmlns", "viewBox"], Lt = ["id"], Dt = ["stop-color"], It = ["stop-color"], Ut = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Nt = ["innerHTML"], zt = {
  __name: "vue-ui-molecule",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(a, { expose: C }) {
    const k = a, { vue_ui_molecule: c } = Qe(), d = B(() => !!k.dataset && k.dataset.length);
    qe(() => {
      _e(k.dataset) && et({
        componentName: "VueUiMolecule",
        type: "dataset"
      });
    });
    const S = f(Te()), n = f(null), u = f(!1), T = f(""), h = f(null), O = f(null), H = f(!1), b = f(null), ie = f(null), Q = f(0), ue = f(0), ce = f(0), t = B({
      get: () => de(),
      set: (e) => e
    });
    function de() {
      const e = Re({
        userConfig: k.config,
        defaultConfig: c
      });
      return e.theme ? {
        ...Re({
          userConfig: tt.vue_ui_molecule[e.theme] || k.config,
          defaultConfig: e
        }),
        customPalette: ot[e.theme] || Fe
      } : e;
    }
    Ze(() => k.config, (e) => {
      t.value = de(), prepareChart(), ue.value += 1, ce.value += 1;
    }, { deep: !0 });
    const { isPrinting: ve, isImaging: fe, generatePdf: he, generateImage: pe } = vt({
      elementId: `cluster_${S.value}`,
      fileName: t.value.style.chart.title.text || "vue-ui-molecule"
    }), Le = B(() => lt(t.value.customPalette)), w = f({
      showTable: t.value.table.show,
      showDataLabels: !0,
      showTooltip: t.value.style.chart.tooltip.show
    });
    function ge(e, o = 0) {
      return Array.isArray(e) && e.length > 0 && e[0].nodes ? ge(e[0].nodes, o + 1) : o;
    }
    function De() {
      const e = ge(k.dataset);
      let o = 100, l = o;
      for (let v = 0; v < e; v += 1)
        o /= 1, l += o;
      return {
        height: l,
        width: l
      };
    }
    const L = f(De()), _ = f(`0 0 ${L.value.width} ${L.value.height}`);
    function ye(e, o = { x: -L.value.width / 2.43, y: L.value.height / 2 }, l = L.value.width / 1.1, v = 24, i = 0, p = 0, j = "#BBBBBB") {
      if (e && e.length > 0) {
        const ae = nt({
          plot: o,
          radius: l,
          sides: e.length,
          rotation: i
        });
        e.forEach((g, z) => {
          const V = ae.coordinates[z];
          let D;
          if (g.ancestor ? g.ancestor.ancestor ? D = g.ancestor.color || j : (D = Le.value[p] || Fe[p] || j, p += 1) : D = j, g.polygonPath = {
            coordinates: [V]
          }, g.circleRadius = v, g.color = D, g.uid = Te(), g.nodes && g.nodes.length > 0) {
            const se = !g.ancestor || !g.ancestor.ancestor ? p : 0;
            g.nodes = ye(
              g.nodes,
              V,
              l / 2.9,
              v / 2.2,
              i + Math.PI * z / g.nodes.length,
              se,
              D
            );
          }
        });
      }
      return e;
    }
    function Ie(e) {
      const o = /* @__PURE__ */ new Set();
      function l(i) {
        i.forEach((p) => {
          p.color && !o.has(p.color) && o.add(p.color), p.nodes && p.nodes.length > 0 && l(p.nodes);
        });
      }
      l(e);
      const v = {};
      return Array.from(o).forEach((i, p) => {
        v[i] = `gradient_${p}`;
      }), v;
    }
    const Ue = B(() => Ie(F.value)), F = B(() => ye(k.dataset));
    function ee() {
      H.value = !1, O.value = null, ie.value = null, b.value = null, oe({
        polygonPath: {
          coordinates: [{ x: L.value.width / 2, y: L.value.height / 2 }]
        },
        circleRadius: 24
      });
    }
    const te = f(null);
    function oe(e) {
      h.value.focus(), Pe(() => {
        te.value && cancelAnimationFrame(te.value);
        const o = _.value.split(" "), l = parseFloat(o[0]), v = parseFloat(o[1]), i = parseFloat(o[2]), p = parseFloat(o[3]), { x: j, y: ae } = e.polygonPath.coordinates[0], { circleRadius: g } = e, z = 8.34, V = j - g * z, D = ae - g * z, se = g * z * 2, Xe = g * z * 2, Ge = Math.sqrt((V - l) ** 2 + (D - v) ** 2), Y = Math.min(1200, Math.max(20, Math.floor(Ge / 10))), je = (V - l) / Y, Ve = (D - v) / Y, Ye = (se - i) / Y, We = (Xe - p) / Y;
        let A = 0;
        function xe() {
          _.value = `${l + je * A} ${v + Ve * A} ${i + Ye * A} ${p + We * A}`, A += t.value.style.chart.zoom.speed, A <= Y && (te.value = requestAnimationFrame(xe));
        }
        xe();
      });
    }
    function Ne(e) {
      O.value === e.uid ? ee() : (O.value = e.uid, ie.value = e, b.value = {
        circleRadius: e.circleRadius,
        polygonPath: {
          coordinates: [{ x: e.polygonPath.coordinates[0].x, y: e.polygonPath.coordinates[0].y }]
        }
      }, oe(e), H.value = e.uid !== F.value[0].uid);
    }
    function ze(e) {
      if (e.target.nodeName !== "circle")
        ee(), H.value = !1;
      else
        return;
    }
    const le = f(null);
    function Be(e) {
      le.value = {
        datapoint: e,
        seriesIndex: -1,
        series: F.value,
        config: t.value
      };
      const o = t.value.style.chart.tooltip.customFormat;
      if (ut(o) && ct(() => o({
        seriesIndex: -1,
        datapoint: e,
        series: F.value,
        config: t.value
      })))
        T.value = o({
          seriesIndex: -1,
          // well, ok
          datapoint: e,
          series: F.value,
          config: t.value
        });
      else {
        let l = "";
        l += `<div style="display:flex;align-items:center;gap:3px"><div style="color:${e.color}">⬤</div><div>${e.name}</div></div>`, e.details && (l += `<div style="width:100%;border-top:1px solid ${t.value.style.chart.tooltip.borderColor};margin-top: 2px">${e.details}</div>`), T.value = `<div style="font-family:inherit">${l}</div>`;
      }
    }
    const me = f(null), X = f(null);
    function Me(e) {
      me.value = e, e ? (u.value = !0, Be(e), X.value = e.uid) : (u.value = !1, T.value = "", X.value = null);
    }
    function q(e) {
      e === "right" && (b.value.polygonPath.coordinates[0].x += b.value.circleRadius), e === "left" && (b.value.polygonPath.coordinates[0].x -= b.value.circleRadius), e === "top" && (b.value.polygonPath.coordinates[0].y -= b.value.circleRadius), e === "bottom" && (b.value.polygonPath.coordinates[0].y += b.value.circleRadius), oe(b.value);
    }
    function Oe(e) {
      const o = [];
      function l(v) {
        v.forEach((i) => {
          const p = {
            name: i.name,
            details: i.details || "-",
            ancestor: i.ancestor && i.ancestor.name || "-",
            color: i.color || ""
          };
          o.push(p), i.nodes && i.nodes.length > 0 && l(i.nodes, i.name);
        });
      }
      return l(e), o;
    }
    const He = B(() => Oe(F.value)), E = B(() => {
      const e = [
        t.value.table.translations.nodeName,
        t.value.table.translations.details,
        t.value.table.translations.ancestor
      ], o = He.value.map((i, p) => [
        {
          color: i.color,
          name: i.name
        },
        i.details,
        i.ancestor || ""
      ]), l = {
        th: {
          backgroundColor: t.value.table.th.backgroundColor,
          color: t.value.table.th.color,
          outline: t.value.table.th.outline
        },
        td: {
          backgroundColor: t.value.table.td.backgroundColor,
          color: t.value.table.td.color,
          outline: t.value.table.td.outline
        },
        breakpoint: t.value.table.responsiveBreakpoint
      }, v = [
        t.value.table.translations.nodeName,
        t.value.table.translations.details,
        t.value.table.translations.ancestor
      ];
      return {
        head: e,
        body: o,
        config: l,
        colNames: v
      };
    });
    function be() {
      Pe(() => {
        const e = E.value.body.map((v, i) => [[v[0].name], [v[1]], [v[2]]]), o = [[t.value.style.chart.title.text], [t.value.style.chart.title.subtitle.text], [[...E.value.head]]].concat(e), l = rt(o);
        it({ csvContent: l, title: t.value.style.chart.title.text || "vue-ui-molecule" });
      });
    }
    function Ee() {
      return F.value;
    }
    const G = f(!1);
    function Ae(e) {
      G.value = e, Q.value += 1;
    }
    function ke() {
      w.value.showTable = !w.value.showTable;
    }
    function Ce() {
      w.value.showDataLabels = !w.value.showDataLabels;
    }
    function $e() {
      w.value.showTooltip = !w.value.showTooltip;
    }
    return C({
      getData: Ee,
      generatePdf: he,
      generateCsv: be,
      generateImage: pe,
      toggleTable: ke,
      toggleLabels: Ce,
      toggleTooltip: $e
    }), (e, o) => (s(), r("div", {
      onMouseleave: o[7] || (o[7] = (l) => {
        me.value = null, X.value = null;
      }),
      ref_key: "moleculeChart",
      ref: h,
      class: we(`vue-ui-molecule ${G.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: K(`font-family:${t.value.style.fontFamily};width:100%; text-align:center;background:${t.value.style.chart.backgroundColor}`),
      id: `cluster_${S.value}`
    }, [
      t.value.style.chart.title.text ? (s(), r("div", {
        key: 0,
        style: K(`width:100%;background:${t.value.style.chart.backgroundColor};`)
      }, [
        (s(), R(dt, {
          key: `title_${ue.value}`,
          config: {
            title: {
              cy: "molecule-div-title",
              ...t.value.style.chart.title
            },
            subtitle: {
              cy: "molecule-div-subtitle",
              ...t.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : m("", !0),
      t.value.userOptions.show && d.value ? (s(), R(ft, {
        ref_key: "details",
        ref: n,
        key: `user_options_${Q.value}`,
        backgroundColor: t.value.style.chart.backgroundColor,
        color: t.value.style.chart.color,
        isPrinting: I(ve),
        isImaging: I(fe),
        uid: S.value,
        hasTooltip: t.value.userOptions.buttons.tooltip && t.value.style.chart.tooltip.show,
        hasPdf: t.value.userOptions.buttons.pdf,
        hasXls: t.value.userOptions.buttons.csv,
        hasImg: t.value.userOptions.buttons.img,
        hasTable: t.value.userOptions.buttons.table,
        hasLabel: t.value.userOptions.buttons.labels,
        hasFullscreen: t.value.userOptions.buttons.fullscreen,
        isTooltip: w.value.showTooltip,
        titles: { ...t.value.userOptions.buttonTitles },
        chartElement: h.value,
        onToggleFullscreen: Ae,
        onGeneratePdf: I(he),
        onGenerateCsv: be,
        onGenerateImage: I(pe),
        onToggleTable: ke,
        onToggleLabels: Ce,
        onToggleTooltip: $e
      }, Je({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: $(() => [
            P(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: $(() => [
            P(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: $(() => [
            P(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: $(() => [
            P(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: $(() => [
            P(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: $(() => [
            P(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: $(({ toggleFullscreen: l, isFullscreen: v }) => [
            P(e.$slots, "optionFullscreen", Z(J({ toggleFullscreen: l, isFullscreen: v })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isTooltip", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : m("", !0),
      d.value ? (s(), r("svg", {
        key: 2,
        xmlns: I(at),
        viewBox: _.value,
        class: we({ "vue-data-ui-fullscreen--on": G.value, "vue-data-ui-fulscreen--off": !G.value }),
        style: K(`overflow: hidden; background:${t.value.style.chart.backgroundColor};color:${t.value.style.chart.color}`),
        onClick: o[0] || (o[0] = M((l) => ze(l), ["stop"]))
      }, [
        x("defs", null, [
          (s(!0), r(y, null, N(Object.keys(Ue.value), (l) => (s(), r("radialGradient", {
            id: `gradient_${l}`,
            cx: "50%",
            cy: "30%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            x("stop", {
              offset: "0%",
              "stop-color": I(st)(l, 0.5)
            }, null, 8, Dt),
            x("stop", {
              offset: "100%",
              "stop-color": l
            }, null, 8, It)
          ], 8, Lt))), 256))
        ]),
        U(xt, {
          dataset: F.value,
          color: t.value.style.chart.links.stroke,
          backgroundColor: t.value.style.chart.backgroundColor
        }, null, 8, ["dataset", "color", "backgroundColor"]),
        U(kt, {
          dataset: F.value,
          hoveredUid: X.value,
          stroke: t.value.style.chart.nodes.stroke,
          strokeHovered: t.value.style.chart.nodes.strokeHovered,
          onZoom: Ne,
          onHover: Me
        }, null, 8, ["dataset", "hoveredUid", "stroke", "strokeHovered"]),
        w.value.showDataLabels ? (s(), R(Pt, {
          key: 0,
          dataset: F.value,
          color: t.value.style.chart.color,
          hoveredUid: X.value
        }, null, 8, ["dataset", "color", "hoveredUid"])) : m("", !0),
        P(e.$slots, "svg", { svg: L.value }, void 0, !0)
      ], 14, St)) : m("", !0),
      H.value ? (s(), R(Ft, {
        key: `direction_pad_${Q.value}`,
        color: t.value.style.chart.color,
        isFullscreen: G.value,
        onMoveLeft: o[1] || (o[1] = (l) => q("left")),
        onMoveRight: o[2] || (o[2] = (l) => q("right")),
        onMoveTop: o[3] || (o[3] = (l) => q("top")),
        onMoveBottom: o[4] || (o[4] = (l) => q("bottom")),
        onReset: o[5] || (o[5] = (l) => {
          ee(), H.value = !1;
        })
      }, null, 8, ["color", "isFullscreen"])) : m("", !0),
      e.$slots.watermark ? (s(), r("div", Ut, [
        P(e.$slots, "watermark", Z(J({ isPrinting: I(ve) || I(fe) })), void 0, !0)
      ])) : m("", !0),
      d.value ? m("", !0) : (s(), R(gt, {
        key: 5,
        config: {
          type: "molecule",
          style: {
            backgroundColor: t.value.style.chart.backgroundColor,
            molecule: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      U(pt, {
        show: w.value.showTooltip && u.value,
        backgroundColor: t.value.style.chart.tooltip.backgroundColor,
        color: t.value.style.chart.tooltip.color,
        borderRadius: t.value.style.chart.tooltip.borderRadius,
        borderColor: t.value.style.chart.tooltip.borderColor,
        borderWidth: t.value.style.chart.tooltip.borderWidth,
        fontSize: t.value.style.chart.tooltip.fontSize,
        backgroundOpacity: t.value.style.chart.tooltip.backgroundOpacity,
        position: t.value.style.chart.tooltip.position,
        offsetY: t.value.style.chart.tooltip.offsetY,
        parent: h.value,
        content: T.value,
        isCustom: t.value.style.chart.tooltip.customFormat && typeof t.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": $(() => [
          P(e.$slots, "tooltip-before", Z(J({ ...le.value })), void 0, !0)
        ]),
        "tooltip-after": $(() => [
          P(e.$slots, "tooltip-after", Z(J({ ...le.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      d.value ? (s(), R(yt, {
        key: 6,
        hideDetails: "",
        config: {
          open: w.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: t.value.style.chart.backgroundColor,
            color: t.value.style.chart.color
          },
          head: {
            backgroundColor: t.value.style.chart.backgroundColor,
            color: t.value.style.chart.color
          }
        }
      }, {
        content: $(() => [
          (s(), R(ht, {
            key: `table_${ce.value}`,
            colNames: E.value.colNames,
            head: E.value.head,
            body: E.value.body,
            config: E.value.config,
            title: `${t.value.style.chart.title.text}${t.value.style.chart.title.subtitle.text ? ` : ${t.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[6] || (o[6] = (l) => w.value.showTable = !1)
          }, {
            th: $(({ th: l }) => [
              x("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Nt)
            ]),
            td: $(({ td: l }) => [
              Ke(Se(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : m("", !0)
    ], 46, Rt));
  }
}, Wt = /* @__PURE__ */ mt(zt, [["__scopeId", "data-v-2555e7ea"]]);
export {
  Wt as default
};
