import { useCssVars as T, computed as _, onMounted as P, ref as A, watch as J, openBlock as a, createElementBlock as o, normalizeStyle as w, createElementVNode as h, createTextVNode as K, toDisplayString as d, unref as r, createCommentVNode as p, Fragment as f, renderList as g, normalizeClass as D, createBlock as F } from "vue";
import { u as Q, o as Z, e as H, g as ee, c as te, t as le, w as b, i as ae, f as oe, X as se, v as z } from "./index-CaV1s-yZ.js";
import { u as I } from "./useNestedProp-tWCzZrLx.js";
import { _ as ue } from "./Shape-CiTElr_0.js";
import ie from "./vue-ui-skeleton-CvFX_ExX.js";
import { _ as ne } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const re = { key: 0 }, ve = { key: 1 }, de = ["xmlns", "viewBox"], ce = ["id"], ye = ["stop-color"], he = ["stop-color"], fe = ["id"], ge = ["stop-color"], pe = ["stop-color"], be = ["id"], me = ["stop-color"], _e = ["stop-color"], xe = { key: 0 }, ke = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "rx"], $e = { key: 1 }, we = ["x", "y", "font-size", "font-weight", "fill"], Ce = ["x", "y", "font-size", "fill"], Le = ["x", "y", "font-size", "fill"], ze = ["height", "width", "x", "onMouseover", "stroke", "stroke-width", "rx", "stroke-dasharray", "onClick"], Se = {
  __name: "vue-ui-sparkhistogram",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(V, { emit: E }) {
    const v = V;
    T((l) => ({
      "627459c9": X.value
    }));
    const { vue_ui_sparkhistogram: W } = Q(), S = _(() => !!v.dataset && v.dataset.length);
    P(() => {
      M();
    });
    function M() {
      Z(v.dataset) ? H({
        componentName: "VueUiSparkHistogram",
        type: "dataset"
      }) : v.dataset.forEach((l, u) => {
        ee({
          datasetObject: l,
          requiredAttributes: ["value"]
        }).forEach((t) => {
          H({
            componentName: "VueUiSparkHistogram",
            type: "datasetSerieAttribute",
            property: t,
            index: u
          });
        });
      });
    }
    const m = A(te()), e = _({
      get: () => N(),
      set: (l) => l
    });
    function N() {
      const l = I({
        userConfig: v.config,
        defaultConfig: W
      });
      return l.theme ? {
        ...I({
          userConfig: le.vue_ui_sparkhistogram[l.theme] || v.config,
          defaultConfig: l
        })
      } : l;
    }
    J(() => v.config, (l) => {
      e.value = N(), M();
    }, { deep: !0 });
    const c = _(() => {
      const l = e.value.style.layout.height, u = e.value.style.layout.width, t = e.value.style.layout.padding.top, s = l - e.value.style.layout.padding.bottom, y = e.value.style.layout.padding.left, x = u - e.value.style.layout.padding.right, k = t + (l - t - e.value.style.layout.padding.bottom) / 2, C = l - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom, $ = u - e.value.style.layout.padding.left - e.value.style.layout.padding.right;
      return {
        bottom: s,
        centerY: k,
        drawingHeight: C,
        drawingWidth: $,
        height: l,
        left: y,
        right: x,
        top: t,
        width: u
      };
    }), B = _(() => Math.max(...v.dataset.map((l) => Math.abs(l.value || 0))));
    function U(l) {
      return Math.abs(l) / B.value;
    }
    const n = _(() => v.dataset.map((l, u) => {
      const t = U(l.value || 0), s = c.value.drawingHeight * t, y = c.value.drawingWidth / v.dataset.length, x = y * (e.value.style.bars.gap / 100), k = y - x, C = c.value.centerY - s / 2, $ = c.value.left + (x / 2 + u * y), j = c.value.left + u * y, L = typeof l.intensity > "u" ? 100 : Math.round(l.intensity * 100), G = l.color ? l.color : l.value >= 0 ? `${e.value.style.bars.colors.positive}${b[L]}` : `${e.value.style.bars.colors.negative}${b[L]}`, Y = l.color ? l.color : l.value >= 0 ? e.value.style.bars.colors.positive : e.value.style.bars.colors.negative, q = l.color ? `url(#gradient_datapoint_${u}_${m.value})` : l.value >= 0 ? `url(#gradient_positive_${u}_${m.value})` : `url(#gradient_negative_${u}_${m.value})`, R = $ + k / 2;
      return {
        ...l,
        color: G,
        gradient: q,
        height: s,
        intensity: L,
        proportion: t,
        stroke: Y,
        textAnchor: R,
        trapX: j,
        unitWidth: y,
        width: k,
        x: $,
        y: C
      };
    })), i = A(null);
    function O(l, u) {
      E("selectDatapoint", { datapoint: l, index: u });
    }
    const X = _(() => `${e.value.style.animation.speedMs}ms`);
    return (l, u) => (a(), o("div", {
      style: w(`width:100%;background:${e.value.style.backgroundColor};font-family:${e.value.style.fontFamily}`),
      onMouseleave: u[1] || (u[1] = (t) => i.value = null)
    }, [
      e.value.style.title.text ? (a(), o("div", {
        key: 0,
        style: w(`width:calc(100% - 12px);background:${e.value.style.backgroundColor};margin:0 auto;margin:${e.value.style.title.margin};padding: 0 6px;text-align:${e.value.style.title.textAlign}`)
      }, [
        h("div", {
          style: w(`font-size:${e.value.style.title.fontSize}px;color:${e.value.style.title.color};font-weight:${e.value.style.title.bold ? "bold" : "normal"}`)
        }, [
          K(d(e.value.style.title.text) + " ", 1),
          i.value !== null ? (a(), o("span", re, "- " + d(n.value[i.value].timeLabel || "") + " " + d(r(ae)(
            e.value.style.labels.value.formatter,
            n.value[i.value].value,
            r(oe)({
              p: e.value.style.labels.value.prefix,
              v: n.value[i.value].value,
              s: e.value.style.labels.value.suffix,
              r: e.value.style.labels.value.rounding
            }),
            { datapoint: n.value[i.value], seriesIndex: i.value }
          )), 1)) : p("", !0),
          ![void 0, null].includes(i.value) && ![null, void 0].includes(n.value[i.value].valueLabel) ? (a(), o("span", ve, "(" + d(n.value[i.value].valueLabel || 0) + ")", 1)) : p("", !0)
        ], 4),
        e.value.style.title.subtitle.text ? (a(), o("div", {
          key: 0,
          style: w(`font-size:${e.value.style.title.subtitle.fontSize}px;color:${e.value.style.title.subtitle.color};font-weight:${e.value.style.title.subtitle.bold ? "bold" : "normal"}`)
        }, d(e.value.style.title.subtitle.text), 5)) : p("", !0)
      ], 4)) : p("", !0),
      S.value ? (a(), o("svg", {
        key: 1,
        xmlns: r(se),
        viewBox: `0 0 ${c.value.width} ${c.value.height}`,
        style: { overflow: "visible" }
      }, [
        h("defs", null, [
          (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("radialGradient", {
            id: `gradient_positive_${s}_${m.value}`,
            cy: "50%",
            cx: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": `${r(z)(e.value.style.bars.colors.positive, 0.05)}${r(b)[t.intensity]}`
            }, null, 8, ye),
            h("stop", {
              offset: "100%",
              "stop-color": `${e.value.style.bars.colors.positive}${r(b)[t.intensity]}`
            }, null, 8, he)
          ], 8, ce))), 256)),
          (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("radialGradient", {
            id: `gradient_negative_${s}_${m.value}`,
            cy: "50%",
            cx: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": `${r(z)(e.value.style.bars.colors.negative, 0.05)}${r(b)[t.intensity]}`
            }, null, 8, ge),
            h("stop", {
              offset: "100%",
              "stop-color": `${e.value.style.bars.colors.negative}${r(b)[t.intensity]}`
            }, null, 8, pe)
          ], 8, fe))), 256)),
          (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("radialGradient", {
            id: `gradient_datapoint_${s}_${m.value}`,
            cy: "50%",
            cx: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": `${r(z)(t.color, 0.05)}${r(b)[t.intensity]}`
            }, null, 8, me),
            h("stop", {
              offset: "100%",
              "stop-color": `${t.color}${r(b)[t.intensity]}`
            }, null, 8, _e)
          ], 8, be))), 256))
        ]),
        !e.value.style.bars.shape || e.value.style.bars.shape === "square" ? (a(), o("g", xe, [
          (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("rect", {
            x: t.x,
            y: t.y,
            height: t.height,
            width: t.width,
            fill: e.value.style.bars.colors.gradient.show ? t.gradient : t.color,
            stroke: t.stroke,
            "stroke-width": e.value.style.bars.strokeWidth,
            rx: `${e.value.style.bars.borderRadius * t.proportion / 12}%`,
            class: D({ "vue-ui-sparkhistogram-shape": e.value.style.animation.show })
          }, null, 10, ke))), 256))
        ])) : (a(), o("g", $e, [
          (a(!0), o(f, null, g(n.value, (t, s) => (a(), F(ue, {
            plot: { x: t.x + t.width / 2, y: t.y + t.height / 2 },
            color: e.value.style.bars.colors.gradient.show ? t.gradient : t.color,
            shape: e.value.style.bars.shape,
            radius: t.height * 0.4,
            class: D({ "vue-ui-sparkhistogram-shape": e.value.style.animation.show })
          }, null, 8, ["plot", "color", "shape", "radius", "class"]))), 256))
        ])),
        (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("text", {
          "text-anchor": "middle",
          x: t.textAnchor,
          y: t.y - e.value.style.labels.value.fontSize / 3 + e.value.style.labels.value.offsetY,
          "font-size": e.value.style.labels.value.fontSize,
          "font-weight": e.value.style.labels.value.bold ? "bold" : "normal",
          fill: e.value.style.labels.value.color
        }, d(e.value.style.labels.value.prefix) + d(isNaN(t.value) ? "" : Number(t.value.toFixed(e.value.style.labels.value.rounding)).toLocaleString()) + d(e.value.style.labels.value.suffix), 9, we))), 256)),
        (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("g", null, [
          t.valueLabel ? (a(), o("text", {
            key: 0,
            x: t.textAnchor,
            y: t.y + t.height + e.value.style.labels.valueLabel.fontSize,
            "font-size": e.value.style.labels.valueLabel.fontSize,
            "text-anchor": "middle",
            fill: e.value.style.labels.valueLabel.color
          }, d(t.valueLabel), 9, Ce)) : p("", !0)
        ]))), 256)),
        (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("g", null, [
          t.timeLabel ? (a(), o("text", {
            key: 0,
            x: t.textAnchor,
            y: c.value.height - e.value.style.labels.timeLabel.fontSize / 2,
            "font-size": e.value.style.labels.timeLabel.fontSize,
            fill: e.value.style.labels.timeLabel.color,
            "text-anchor": "middle"
          }, d(t.timeLabel), 9, Le)) : p("", !0)
        ]))), 256)),
        (a(!0), o(f, null, g(n.value, (t, s) => (a(), o("g", null, [
          h("rect", {
            height: c.value.height,
            width: t.unitWidth,
            fill: "transparent",
            x: t.trapX,
            y: 0,
            onMouseover: (y) => i.value = s,
            onMouseleave: u[0] || (u[0] = (y) => i.value = null),
            stroke: i.value !== null && i.value === s ? e.value.style.selector.stroke : "",
            "stroke-width": i.value !== null && i.value === s ? e.value.style.selector.strokeWidth : 0,
            rx: e.value.style.selector.borderRadius,
            "stroke-dasharray": e.value.style.selector.strokeDasharray,
            onClick: () => O(t, s)
          }, null, 40, ze)
        ]))), 256))
      ], 8, de)) : p("", !0),
      S.value ? p("", !0) : (a(), F(ie, {
        key: 2,
        config: {
          type: "sparkHistogram",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkHistogram: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 36));
  }
}, Ie = /* @__PURE__ */ ne(Se, [["__scopeId", "data-v-7a469df4"]]);
export {
  Ie as default
};
