import { computed as p, ref as h, watch as Q, onMounted as ke, onBeforeUnmount as be, openBlock as r, createElementBlock as n, normalizeClass as ee, normalizeStyle as R, createBlock as E, withCtx as I, toDisplayString as S, createCommentVNode as g, unref as c, createSlots as _e, renderSlot as x, normalizeProps as te, guardReactiveProps as ae, createElementVNode as f, Fragment as O, renderList as A } from "vue";
import { u as xe, c as we, t as Fe, a as Se, p as le, b as ze, o as se, d as $e, e as X, g as re, m as oe, X as Ce, w as D, J as N, i as Me, f as Pe, D as ue } from "./index-CaV1s-yZ.js";
import { t as Ie, u as Oe } from "./useResponsive-NZB-WLRF.js";
import { u as Xe, U as Ne } from "./usePrinter-rvJyT65A.js";
import Ye from "./vue-ui-skeleton-CvFX_ExX.js";
import { _ as Ge } from "./Title-gUz6GDA3.js";
import { u as ne } from "./useNestedProp-tWCzZrLx.js";
import { _ as Re } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ee = ["id"], Ae = { key: 0 }, De = ["xmlns", "viewBox"], je = ["id"], Ue = ["stop-color"], Be = ["stop-color"], Le = ["stop-color"], We = ["id"], Te = ["stdDeviation"], Ve = ["d", "fill", "stroke"], qe = ["d", "filter"], He = ["y", "width", "height", "fill"], Je = ["x", "y", "text-anchor", "font-size", "font-weight", "fill"], Ze = ["x", "y", "font-size", "font-weight", "fill"], Ke = { key: 1 }, Qe = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], et = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], tt = ["x1", "y1", "x2", "y2", "stroke-width", "filter"], at = { key: 2 }, lt = ["d", "fill", "stroke", "stroke-width"], st = ["cx", "cy", "fill", "r", "stroke-width", "stroke"], rt = ["x", "y", "font-size", "fill"], ot = {
  key: 3,
  class: "vue-data-ui-watermark"
}, ut = {
  __name: "vue-ui-gauge",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(Y, { expose: ie }) {
    const o = Y, { vue_ui_gauge: ce } = xe(), z = p(() => !!o.dataset && Object.keys(o.dataset).length > 0 && o.dataset.series && o.dataset.series.length), m = h(we()), ve = h(null), j = h(0), $ = h(null), U = h(null), B = h(null), L = h(0), e = p({
      get: () => W(),
      set: (a) => a
    });
    Q(() => o.config, (a) => {
      e.value = W(), Z(), L.value += 1;
    }, { deep: !0 });
    function W() {
      const a = ne({
        userConfig: o.config,
        defaultConfig: ce
      });
      return a.theme ? {
        ...ne({
          userConfig: Fe.vue_ui_gauge[a.theme] || o.config,
          defaultConfig: a
        }),
        customPalette: Se[a.theme] || le
      } : a;
    }
    const { isPrinting: T, isImaging: V, generatePdf: q, generateImage: H } = Xe({
      elementId: `vue-ui-gauge_${m.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-gauge"
    }), de = p(() => ze(e.value.customPalette)), b = p(() => {
      if (!z.value || se(o.dataset.series || {}))
        return {
          value: 0,
          series: [
            {
              from: 0,
              to: 0
            }
          ]
        };
      const a = [];
      (o.dataset.series || []).forEach((l) => {
        a.push(l.from || 0), a.push(l.to || 0);
      });
      const s = Math.max(...a);
      return {
        ...o.dataset,
        series: (o.dataset.series || []).map((l, i) => ({
          ...l,
          color: $e(l.color) || de.value[i] || le[i],
          value: ((l.to || 0) - (l.from || 0)) / s * 100
        }))
      };
    }), y = h(512), t = h({
      height: 358.4,
      width: y.value,
      top: 0,
      bottom: 358.4,
      centerX: 179.2,
      centerY: y.value / 2,
      labelFontSize: 18,
      legendFontSize: e.value.style.chart.legend.fontSize,
      pointerRadius: e.value.style.chart.layout.pointer.circle.radius,
      trackSize: e.value.style.chart.layout.track.size,
      pointerSize: e.value.style.chart.layout.pointer.size,
      pointerStrokeWidth: e.value.style.chart.layout.pointer.strokeWidth,
      markerOffset: e.value.style.chart.layout.markers.offsetY + 3
    }), C = h(0), w = h(0), v = h(e.value.style.chart.animation.use ? 0 : o.dataset.value);
    Q(() => o.dataset.value, () => {
      K(o.dataset.value);
    });
    const d = p(() => {
      const a = t.value.width / 2, s = u.value.base, l = Math.PI * ((v.value + 0 - w.value) / (C.value - w.value)) + Math.PI;
      return {
        x1: a,
        y1: s,
        x2: a + u.value.pointerSize * t.value.pointerSize * 0.9 * Math.cos(l),
        y2: s + u.value.pointerSize * t.value.pointerSize * 0.9 * Math.sin(l)
      };
    }), J = p(() => {
      const a = t.value.width / 2, s = u.value.base, l = Math.PI * ((v.value + 0 - w.value) / (C.value - w.value)) + Math.PI, i = a + u.value.pointerSize * t.value.pointerSize * 0.9 * Math.cos(l), P = s + u.value.pointerSize * t.value.pointerSize * 0.9 * Math.sin(l), k = t.value.pointerRadius, ye = a + k * Math.cos(l + Math.PI / 2), ge = s + k * Math.sin(l + Math.PI / 2), pe = a + k * Math.cos(l - Math.PI / 2), me = s + k * Math.sin(l - Math.PI / 2);
      return isNaN(i) ? null : `M ${i},${P} ${ye},${ge} ${pe},${me} Z`;
    }), G = p(() => {
      for (let a = 0; a < b.value.series.length; a += 1) {
        const { color: s, from: l, to: i } = b.value.series[a];
        if (v.value >= l && v.value <= i)
          return s;
      }
      return "#2D353C";
    }), M = h(null);
    function Z() {
      if (se(o.dataset) ? X({
        componentName: "VueUiGauge",
        type: "dataset"
      }) : (re({
        datasetObject: o.dataset,
        requiredAttributes: ["value", "series"]
      }).forEach((a) => {
        X({
          componentName: "VueUiGauge",
          type: "datasetAttribute",
          property: a
        });
      }), Object.hasOwn(o.dataset, "series") && (o.dataset.series.length ? o.dataset.series.forEach((a, s) => {
        re({
          datasetObject: a,
          requiredAttributes: ["from", "to"]
        }).forEach((l) => {
          X({
            componentName: "VueUiGauge",
            type: "datasetSerieAttribute",
            property: l,
            index: s
          });
        });
      }) : X({
        componentName: "VueUiGauge",
        type: "datasetAttributeEmpty",
        property: "series"
      }))), K(o.dataset.value || 0), e.value.responsive) {
        const a = Ie(() => {
          const { width: s, height: l } = Oe({
            chart: $.value,
            title: e.value.style.chart.title.text ? U.value : null,
            legend: B.value
          });
          t.value.width = s, t.value.height = l, t.value.centerX = s / 2, t.value.centerY = y.value / 2 / 358.4 * l, t.value.bottom = l, t.value.labelFontSize = 18 / y.value * Math.min(l, s) < 10 ? 10 : 18 / y.value * Math.min(l, s), t.value.legendFontSize = e.value.style.chart.legend.fontSize / y.value * Math.min(l, s) < 14 ? 14 : e.value.style.chart.legend.fontSize / y.value * Math.min(l, s), t.value.pointerRadius = e.value.style.chart.layout.pointer.circle.radius / y.value * Math.min(l, s), t.value.trackSize = e.value.style.chart.layout.track.size / y.value * Math.min(l, s), t.value.pointerStrokeWidth = ue({
            relator: Math.min(s, l),
            adjuster: y.value,
            source: e.value.style.chart.layout.pointer.strokeWidth,
            threshold: 2,
            fallback: 2
          }), t.value.markerOffset = ue({
            relator: Math.max(s, l),
            adjuster: y.value,
            source: e.value.style.chart.layout.markers.offsetY + 3,
            threshold: 2,
            fallback: 2
          });
        });
        M.value = new ResizeObserver(a), M.value.observe($.value.parentNode);
      }
    }
    ke(() => {
      Z();
    }), be(() => {
      M.value && M.value.disconnect();
    });
    function K(a) {
      const s = [];
      (b.value.series || []).forEach((k) => {
        s.push(k.from || 0), s.push(k.to || 0);
      }), C.value = Math.max(...s), w.value = Math.min(...s);
      let l = e.value.style.chart.animation.speed;
      const i = Math.abs(a - v.value) / (l * 60);
      function P() {
        v.value < a ? v.value = Math.min(v.value + i, a) : v.value > a && (v.value = Math.max(v.value - i, a)), v.value !== a && requestAnimationFrame(P);
      }
      P();
    }
    const u = p(() => {
      const a = e.value.responsive ? Math.min(t.value.width, t.value.height) : t.value.width;
      return {
        arcs: a / 2.5,
        gradients: a / 2.75,
        base: e.value.responsive ? t.value.height / 2 : t.value.height * 0.7,
        ratingBase: e.value.responsive ? t.value.height / 2 + t.value.height / 4 : t.value.height * 0.9,
        pointerSize: e.value.responsive ? Math.min(t.value.width, t.value.height) / 3 : t.value.width / 3.2
      };
    }), _ = p(() => oe(
      { series: b.value.series },
      t.value.width / 2,
      u.value.base,
      u.value.arcs,
      u.value.arcs,
      1,
      1,
      1,
      180,
      109.9495,
      40 * t.value.trackSize
    )), he = p(() => oe(
      { series: b.value.series },
      t.value.width / 2,
      u.value.base,
      u.value.gradients,
      u.value.gradients,
      1,
      1,
      1,
      180,
      109.9495,
      2 * t.value.trackSize
    )), F = h(!1);
    function fe(a) {
      F.value = a, j.value += 1;
    }
    return ie({
      generatePdf: q,
      generateImage: H
    }), (a, s) => (r(), n("div", {
      class: ee(`vue-ui-gauge ${F.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      ref_key: "gaugeChart",
      ref: $,
      id: `vue-ui-gauge_${m.value}`,
      style: R(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.style.chart.title.text ? (r(), n("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: U,
        style: R(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:12px`)
      }, [
        (r(), E(Ge, {
          key: `title_${L.value}`,
          config: {
            title: {
              cy: "gauge-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "gauge-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, {
          default: I(() => [
            e.value.translations.base && Y.dataset.base ? (r(), n("span", Ae, S(e.value.translations.base) + ": " + S(Y.dataset.base), 1)) : g("", !0)
          ]),
          _: 1
        }, 8, ["config"]))
      ], 4)) : g("", !0),
      e.value.userOptions.show && z.value ? (r(), E(Ne, {
        ref_key: "details",
        ref: ve,
        key: `user_options_${j.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: c(V),
        isPrinting: c(T),
        uid: m.value,
        hasXls: !1,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: F.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: $.value,
        onToggleFullscreen: fe,
        onGeneratePdf: c(q),
        onGenerateImage: c(H)
      }, _e({ _: 2 }, [
        a.$slots.optionPdf ? {
          name: "optionPdf",
          fn: I(() => [
            x(a.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        a.$slots.optionImg ? {
          name: "optionImg",
          fn: I(() => [
            x(a.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        a.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: I(({ toggleFullscreen: l, isFullscreen: i }) => [
            x(a.$slots, "optionFullscreen", te(ae({ toggleFullscreen: l, isFullscreen: i })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : g("", !0),
      z.value ? (r(), n("svg", {
        key: 2,
        xmlns: c(Ce),
        class: ee({ "vue-data-ui-fullscreen--on": F.value, "vue-data-ui-fulscreen--off": !F.value }),
        viewBox: `0 0 ${t.value.width <= 0 ? 10 : t.value.width} ${t.value.height <= 0 ? 10 : t.value.height}`,
        style: R(`max-width:100%;overflow:hidden !important;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        f("defs", null, [
          f("radialGradient", {
            id: `gradient_${m.value}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `#FFFFFF${c(D)[1]}`
            }, null, 8, Ue),
            f("stop", {
              offset: "80%",
              "stop-color": `#FFFFFF${c(D)[e.value.style.chart.layout.track.gradientIntensity]}`
            }, null, 8, Be),
            f("stop", {
              offset: "100%",
              "stop-color": `#FFFFFF${c(D)[1]}`
            }, null, 8, Le)
          ], 8, je)
        ]),
        f("defs", null, [
          f("filter", {
            id: `blur_${m.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            f("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 100 / e.value.style.chart.layout.track.gradientIntensity
            }, null, 8, Te)
          ], 8, We)
        ]),
        (r(!0), n(O, null, A(_.value, (l, i) => (r(), n("path", {
          key: `arc_${i}`,
          d: l.arcSlice,
          fill: l.color,
          stroke: e.value.style.chart.backgroundColor,
          "stroke-linecap": "round"
        }, null, 8, Ve))), 128)),
        e.value.style.chart.layout.track.useGradient ? (r(), n(O, { key: 0 }, [
          (r(!0), n(O, null, A(he.value, (l, i) => (r(), n("path", {
            key: `arc_${i}`,
            d: l.arcSlice,
            fill: "#FFFFFF",
            stroke: "none",
            "stroke-linecap": "round",
            filter: `url(#blur_${m.value})`
          }, null, 8, qe))), 128)),
          f("rect", {
            x: 0,
            y: u.value.base,
            width: t.value.width <= 0 ? 1e-4 : t.value.width,
            height: t.value.height * 0.3 <= 0 ? 1e-4 : t.value.height * 0.3,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, He)
        ], 64)) : g("", !0),
        (r(!0), n(O, null, A(_.value, (l, i) => (r(), n("text", {
          x: c(N)({
            centerX: t.value.width / 2,
            centerY: u.value.base,
            initX: l.center.startX,
            initY: l.center.startY,
            offset: t.value.markerOffset
          }).x,
          y: c(N)({
            centerX: t.value.width / 2,
            centerY: u.value.base,
            initX: l.center.startX,
            initY: l.center.startY,
            offset: t.value.markerOffset
          }).y,
          "text-anchor": l.center.startX < t.value.width / 2 - 5 ? "end" : l.center.startX > t.value.width / 2 + 5 ? "start" : "middle",
          "font-size": t.value.labelFontSize * e.value.style.chart.layout.markers.fontSizeRatio,
          "font-weight": `${e.value.style.chart.layout.markers.bold ? "bold" : "normal"}`,
          fill: e.value.style.chart.layout.markers.color
        }, S(l.from.toFixed(e.value.style.chart.layout.markers.roundingValue)), 9, Je))), 256)),
        f("text", {
          x: c(N)({
            centerX: t.value.width / 2,
            centerY: u.value.base,
            initX: _.value.at(-1).endX,
            initY: _.value.at(-1).endY,
            offset: t.value.markerOffset
          }).x,
          y: c(N)({
            centerX: t.value.width / 2,
            centerY: u.value.base,
            initX: _.value.at(-1).endX,
            initY: _.value.at(-1).endY,
            offset: t.value.markerOffset
          }).y,
          "text-anchor": "start",
          "font-size": t.value.labelFontSize * e.value.style.chart.layout.markers.fontSizeRatio,
          "font-weight": `${e.value.style.chart.layout.markers.bold ? "bold" : "normal"}`,
          fill: e.value.style.chart.layout.markers.color
        }, S(C.value.toFixed(e.value.style.chart.layout.markers.roundingValue)), 9, Ze),
        e.value.style.chart.layout.pointer.type === "rounded" ? (r(), n("g", Ke, [
          isNaN(d.value.x2) ? g("", !0) : (r(), n("line", {
            key: 0,
            x1: d.value.x1,
            y1: d.value.y1,
            x2: d.value.x2,
            y2: d.value.y2,
            stroke: e.value.style.chart.layout.pointer.stroke,
            "stroke-width": t.value.pointerStrokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Qe)),
          isNaN(d.value.x2) ? g("", !0) : (r(), n("line", {
            key: 1,
            x1: d.value.x1,
            y1: d.value.y1,
            x2: d.value.x2,
            y2: d.value.y2,
            stroke: e.value.style.chart.layout.pointer.useRatingColor ? G.value : e.value.style.chart.layout.pointer.color,
            "stroke-linecap": "round",
            "stroke-width": t.value.pointerStrokeWidth * 0.7
          }, null, 8, et)),
          !isNaN(d.value.x2) && e.value.style.chart.layout.track.useGradient ? (r(), n("line", {
            key: 2,
            x1: d.value.x1,
            y1: d.value.y1,
            x2: d.value.x2,
            y2: d.value.y2,
            stroke: "white",
            "stroke-linecap": "round",
            "stroke-width": t.value.pointerStrokeWidth * 0.3,
            filter: `url(#blur_${m.value})`
          }, null, 8, tt)) : g("", !0)
        ])) : (r(), n("g", at, [
          J.value ? (r(), n("path", {
            key: 0,
            d: J.value,
            fill: e.value.style.chart.layout.pointer.useRatingColor ? G.value : e.value.style.chart.layout.pointer.color,
            stroke: e.value.style.chart.layout.pointer.stroke,
            "stroke-width": e.value.style.chart.layout.pointer.circle.strokeWidth,
            "stroke-linejoin": "round"
          }, null, 8, lt)) : g("", !0)
        ])),
        f("circle", {
          cx: t.value.width / 2,
          cy: u.value.base,
          fill: e.value.style.chart.layout.pointer.circle.color,
          r: t.value.pointerRadius <= 0 ? 1e-4 : t.value.pointerRadius,
          "stroke-width": e.value.style.chart.layout.pointer.circle.strokeWidth,
          stroke: e.value.style.chart.layout.pointer.circle.stroke
        }, null, 8, st),
        f("text", {
          x: t.value.width / 2,
          y: u.value.ratingBase,
          "text-anchor": "middle",
          "font-size": t.value.legendFontSize,
          "font-weight": "bold",
          fill: e.value.style.chart.legend.useRatingColor ? G.value : e.value.style.chart.legend.color
        }, S(c(Me)(
          e.value.style.chart.legend.formatter,
          v.value,
          c(Pe)({
            p: e.value.style.chart.legend.prefix + (e.value.style.chart.legend.showPlusSymbol && v.value > 0 ? "+" : ""),
            v: v.value,
            s: e.value.style.chart.legend.suffix,
            r: e.value.style.chart.legend.roundingValue
          })
        )), 9, rt),
        x(a.$slots, "svg", { svg: t.value }, void 0, !0)
      ], 14, De)) : g("", !0),
      a.$slots.watermark ? (r(), n("div", ot, [
        x(a.$slots, "watermark", te(ae({ isPrinting: c(T) || c(V) })), void 0, !0)
      ])) : g("", !0),
      z.value ? g("", !0) : (r(), E(Ye, {
        key: 4,
        config: {
          type: "gauge",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            gauge: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      f("div", {
        ref_key: "chartLegend",
        ref: B
      }, [
        x(a.$slots, "legend", { legend: b.value }, void 0, !0)
      ], 512)
    ], 14, Ee));
  }
}, gt = /* @__PURE__ */ Re(ut, [["__scopeId", "data-v-4bb1fc5d"]]);
export {
  gt as default
};
