import { computed as k, ref as d, watch as Fe, onMounted as Xe, onBeforeUnmount as He, openBlock as s, createElementBlock as n, normalizeClass as P, normalizeStyle as se, createBlock as O, createCommentVNode as y, unref as r, createSlots as We, withCtx as m, renderSlot as $, normalizeProps as q, guardReactiveProps as J, createElementVNode as b, Fragment as w, renderList as L, toDisplayString as F, createVNode as qe, createTextVNode as K, nextTick as Je, pushScopeId as Ke, popScopeId as Qe } from "vue";
import { u as Ze, c as je, t as et, a as tt, p as Q, o as lt, e as A, b as at, F as Ie, d as ot, m as De, f as C, X as st, H as ut, k as V, n as ue, i as E, x as ze, y as nt, q as rt, r as it } from "./index-CaV1s-yZ.js";
import { t as dt, u as ct } from "./useResponsive-NZB-WLRF.js";
import { _ as vt } from "./Title-gUz6GDA3.js";
import { u as ht, U as ft } from "./usePrinter-rvJyT65A.js";
import { D as yt } from "./DataTable-e2fnfjXV.js";
import { _ as pt } from "./Tooltip-DfSM1mNP.js";
import { L as bt } from "./Legend-5cQ0xZjK.js";
import gt from "./vue-ui-skeleton-CvFX_ExX.js";
import mt from "./vue-ui-accordion-CpzGQ63y.js";
import { u as Pe } from "./useNestedProp-tWCzZrLx.js";
import { _ as wt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ne = (M) => (Ke("data-v-7e1c384d"), M = M(), Qe(), M), xt = ["id"], _t = ["xmlns", "viewBox"], kt = ["id", "fr"], $t = /* @__PURE__ */ ne(() => /* @__PURE__ */ b("stop", {
  offset: "0%",
  "stop-color": "#FFFFFF",
  "stop-opacity": "0"
}, null, -1)), Lt = ["offset", "stop-opacity"], Ct = /* @__PURE__ */ ne(() => /* @__PURE__ */ b("stop", {
  offset: "100%",
  "stop-color": "#FFFFFF",
  "stop-opacity": "0"
}, null, -1)), St = ["id"], Nt = ["id"], Tt = /* @__PURE__ */ ne(() => /* @__PURE__ */ b("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Ft = ["id"], It = ["flood-color"], Dt = ["cx", "cy", "r", "fill", "filter"], zt = ["d", "fill", "stroke", "stroke-width", "filter"], Pt = { key: 0 }, Ot = ["d", "fill"], At = { key: 1 }, Vt = ["x", "y", "font-size", "font-weight", "fill"], Mt = { key: 2 }, Bt = ["filter"], Ut = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Rt = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Et = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Gt = ["d", "fill", "onMouseenter", "onClick"], Yt = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Xt = {
  key: 0,
  class: "vue-ui-nested-donuts-legend-title"
}, Ht = ["onClick"], Wt = ["innerHTML"], qt = {
  __name: "vue-ui-nested-donuts",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(M, { expose: Oe, emit: re }) {
    const I = M, { vue_ui_nested_donuts: Ae } = Ze(), G = k(() => !!I.dataset && I.dataset.length), g = d(je()), Z = d(!1), j = d(""), Ve = d(null), ie = d(0), B = d(null), de = d(null), ee = d(null), ce = d(0), ve = d(0), he = d(0), U = d(!1);
    function Me(t) {
      U.value = t, ie.value += 1;
    }
    const e = k({
      get: () => fe(),
      set: (t) => t
    });
    function fe() {
      const t = Pe({
        userConfig: I.config,
        defaultConfig: Ae
      });
      return t.theme ? {
        ...Pe({
          userConfig: et.vue_ui_nested_donuts[t.theme] || I.config,
          defaultConfig: t
        }),
        customPalette: tt[t.theme] || Q
      } : t;
    }
    Fe(() => I.config, (t) => {
      e.value = fe(), ye(), ce.value += 1, ve.value += 1, he.value += 1;
    }, { deep: !0 });
    const Y = d(null);
    Xe(() => {
      ye();
    });
    function ye() {
      if (lt(I.dataset) && A({
        componentName: "VueUiNestedDonuts",
        type: "dataset"
      }), e.value.responsive) {
        const t = dt(() => {
          const { width: u, height: a } = ct({
            chart: B.value,
            title: e.value.style.chart.title.text ? de.value : null,
            legend: e.value.style.chart.legend.show ? ee.value : null
          });
          v.value.width = u, v.value.height = a;
        });
        Y.value = new ResizeObserver(t), Y.value.observe(B.value.parentNode);
      }
    }
    He(() => {
      Y.value && Y.value.disconnect();
    });
    const { isPrinting: pe, isImaging: be, generatePdf: ge, generateImage: me } = ht({
      elementId: `nested_donuts_${g.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-nested-donuts"
    }), Be = k(() => at(e.value.customPalette)), x = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), v = d({
      height: 512,
      width: 512
    });
    function Ue({ datapoint: t, index: u }) {
      re("selectDatapoint", { datapoint: t, index: u });
    }
    const f = d([]), S = k(() => (I.dataset.forEach((t, u) => {
      [null, void 0].includes(t.name) && A({
        componentName: "VueUiNestedDonuts",
        type: "datasetSerieAttribute",
        property: "name",
        index: u
      }), [null, void 0].includes(t.series) ? A({
        componentName: "VueUiNestedDonuts",
        type: "datasetSerieAttribute",
        property: "series",
        index: u
      }) : t.series.length === 0 ? A({
        componentName: "VueUiNestedDonuts",
        type: "datasetAttributeEmpty",
        property: `series at index ${u}`
      }) : t.series.forEach((a, o) => {
        [null, void 0].includes(a.name) && A({
          componentName: "VueUiNestedDonuts",
          type: "datasetSerieAttribute",
          property: "name",
          index: o,
          key: "serie"
        }), [null, void 0].includes(a.values) && A({
          componentName: "VueUiNestedDonuts",
          type: "datasetSerieAttribute",
          property: "values",
          index: o,
          key: "serie"
        });
      });
    }), I.dataset.map((t, u) => ({
      ...t,
      total: t.series.filter((a) => !f.value.includes(a.id)).map((a) => Ie(a.values).reduce((o, l) => o + l, 0)).reduce((a, o) => a + o, 0),
      datasetIndex: u,
      id: `${g.value}_${u}`,
      series: t.series.map((a, o) => ({
        name: a.name,
        arcOf: t.name,
        arcOfId: `${g.value}_${u}`,
        id: `${g.value}_${u}_${o}`,
        seriesIndex: o,
        datasetIndex: u,
        color: ot(a.color) || Be.value[o] || Q[o] || Q[o % Q.length],
        value: Ie(a.values).reduce((l, i) => l + i, 0),
        absoluteValues: a.values || []
      }))
    })))), N = k(() => Math.min(v.value.height, v.value.width) * (e.value.style.chart.layout.donut.strokeWidth / 512)), we = k(() => [...S.value].map((t, u) => {
      const a = t.series.filter((o) => !f.value.includes(o.id)).map((o) => o.value).reduce((o, l) => o + l, 0);
      return {
        ...t,
        total: a,
        series: t.series.filter((o) => !f.value.includes(o.id)).map((o) => ({
          ...o,
          proportion: o.value / a
        }))
      };
    }));
    function Re(t, u, a) {
      let o = 0;
      for (let l = 0; l < t.length; l += 1)
        a.includes(t[l]) && (o += 1);
      return o < u;
    }
    const h = d(we.value);
    Fe(() => we.value, (t) => h.value = t);
    const xe = d(null), _e = d(null);
    function te(t) {
      re("selectLegend", t);
      const u = S.value.flatMap((c) => c.series).find((c) => c.id === t.id), a = h.value.flatMap((c) => c.series).find((c) => c.id === t.id);
      let l = a ? a.value : 0;
      const i = S.value.find((c) => c.id === u.arcOfId).series.map((c) => c.id), p = Re(i, i.length - 1, f.value);
      if (f.value.includes(t.id)) {
        let c = function() {
          l > u.value ? (cancelAnimationFrame(xe.value), h.value = h.value.map((_) => ({
            ..._,
            series: _.series.map((T) => T.id == t.id ? {
              ...T,
              value: u.value
            } : T)
          }))) : (l += u.value * 0.025, h.value = h.value.map((_) => ({
            ..._,
            series: _.series.map((T) => T.id === t.id ? {
              ...T,
              value: l
            } : T)
          })), xe.value = requestAnimationFrame(c));
        };
        f.value = f.value.filter((_) => _ !== t.id), c();
      } else if (p) {
        let c = function() {
          l < 0.1 ? (cancelAnimationFrame(_e.value), f.value.push(t.id), h.value = h.value.map((_, T) => ({
            ..._,
            series: _.series.map((z) => z.id === t.id ? {
              ...z,
              value: 0
            } : z)
          }))) : (l /= 1.1, h.value = h.value.map((_, T) => ({
            ..._,
            series: _.series.map((z) => z.id === t.id ? {
              ...z,
              value: l
            } : z)
          })), _e.value = requestAnimationFrame(c));
        };
        c();
      }
    }
    const R = k(() => h.value.map((t, u) => {
      const a = u * N.value / S.value.length;
      return {
        ...t,
        radius: N.value - a,
        donut: De(
          { series: t.series },
          v.value.width / 2,
          v.value.height / 2,
          N.value - a,
          N.value - a,
          1.99999,
          2,
          1,
          360,
          105.25,
          N.value / S.value.length * e.value.style.chart.layout.donut.spacingRatio
        )
      };
    })), ke = k(() => [...S.value].map((t, u) => {
      const a = u * N.value / S.value.length;
      return {
        sizeRatio: a,
        donut: De(
          { series: [{ value: 1 }] },
          v.value.width / 2,
          v.value.height / 2,
          N.value - a,
          N.value - a,
          1.99999,
          2,
          1,
          360,
          105.25,
          N.value / S.value.length * e.value.style.chart.layout.donut.spacingRatio
        )[0]
      };
    })), $e = d(null), X = d(null), H = d(null), le = d(null);
    function Ee({ datapoint: t, _relativeIndex: u, seriesIndex: a }) {
      $e.value = t.arcOfId, X.value = t.id, H.value = a, le.value = {
        datapoint: t,
        seriesIndex: a,
        series: h.value,
        config: e.value
      };
      const o = e.value.style.chart.tooltip.customFormat;
      if (ze(o) && nt(() => o({
        seriesIndex: a,
        datapoint: t,
        series: h.value,
        config: e.value
      })))
        j.value = o({
          seriesIndex: a,
          datapoint: t,
          series: h.value,
          config: e.value
        });
      else {
        let l = "";
        if (e.value.style.chart.tooltip.showAllItemsAtIndex && f.value.length === 0) {
          const i = h.value.map((p) => p.series.find((c) => c.seriesIndex === a));
          i.forEach((p, c) => {
            if (!p) return "";
            l += `
                    <div style="display:flex; flex-direction: column; justify-content:flex-start; align-items:flex-start;padding:6px 0; ${c < i.length - 1 ? `border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor}` : ""}">
                        <div style="display:flex; flex-direction: row; gap: 3px; justify-content:flex-start; align-items:center;">
                            <svg viewBox="0 0 20 20" height="${e.value.style.chart.tooltip.fontSize}" width="${e.value.style.chart.tooltip.fontSize}">
                                <circle cx="10" cy="10" r="10" fill="${p.color}"/>
                            </svg>
                            <span>
                                ${p.arcOf ?? ""} - ${p.name}
                            </span>
                        </div>
                        <span>
                            ${e.value.style.chart.tooltip.showValue ? `<b>${E(
              e.value.style.chart.layout.labels.dataLabels.formatter,
              t.value,
              C({
                p: e.value.style.chart.layout.labels.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.labels.dataLabels.suffix,
                r: e.value.style.chart.tooltip.roundingValue
              }),
              { datapoint: t, seriesIndex: a }
            )}
                        </b>` : ""}
                            ${e.value.style.chart.tooltip.showPercentage ? `(${C({
              v: p.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            })})` : ""}
                        </span>
                    </div>
                `;
          });
        } else
          l += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.arcOf ?? ""} - ${t.name}</div>`, l += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${t.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (l += `<b>${E(
            e.value.style.chart.layout.labels.dataLabels.formatter,
            t.value,
            C({
              p: e.value.style.chart.layout.labels.dataLabels.prefix,
              v: t.value,
              s: e.value.style.chart.layout.labels.dataLabels.suffix,
              r: e.value.style.chart.tooltip.roundingValue
            }),
            { datapoint: t, seriesIndex: a }
          )}</b>`), e.value.style.chart.tooltip.showPercentage && (e.value.style.chart.tooltip.showValue ? l += `<span>(${C({
            v: t.proportion * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          })})</span></div>` : l += `<b>${C({
            v: t.proportion * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          })}</b></div>`);
        j.value = `<div style="font-size:${e.value.style.chart.tooltip.fontSize}px">${l}</div>`;
      }
      Z.value = !0;
    }
    function ae(t) {
      return t.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function Le(t, u) {
      if (!e.value.useBlurOnHover)
        return "";
      if (e.value.style.chart.tooltip.showAllItemsAtIndex && f.value.length === 0)
        return [null, void 0].includes(H.value) || H.value === u ? "" : `url(#blur_${g.value})`;
      if (!e.value.style.chart.tooltip.showAllItemsAtIndex || f.value.length)
        return [null, void 0].includes(X.value) || X.value === t.id ? "" : `url(#blur_${g.value})`;
    }
    const oe = k(() => S.value.map((t, u) => t.series.map((a, o) => ({
      name: a.name,
      color: a.color,
      value: a.value,
      shape: "circle",
      arcOf: a.arcOf,
      id: a.id,
      seriesIndex: o,
      datasetIndex: u,
      total: t.series.filter((l) => !f.value.includes(l.id)).map((l) => l.value).reduce((l, i) => l + i, 0)
    })).map((a) => ({
      ...a,
      opacity: f.value.includes(a.id) ? 0.5 : 1,
      segregate: () => te(a),
      isSegregated: f.value.includes(a.id)
    })))), Ge = k(() => ({
      cy: "nested-donuts-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), D = k(() => {
      const t = h.value.flatMap((a) => a.series.map((o) => ({
        name: `${a.name} - ${o.name}`,
        color: o.color,
        total: a.total
      }))), u = h.value.flatMap((a) => a.series.map((o) => o.value));
      return { head: t, body: u };
    });
    function Ce() {
      Je(() => {
        const t = D.value.head.map((o, l) => [[
          o.name
        ], [D.value.body[l]], [isNaN(D.value.body[l] / o.total) ? "-" : D.value.body[l] / o.total * 100]]), u = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), a = rt(u);
        it({ csvContent: a, title: e.value.style.chart.title.text || "vue-ui-nested-donuts" });
      });
    }
    const W = k(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ], u = D.value.head.map((l, i) => {
        const p = C({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: D.value.body[i], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: l.color,
            name: l.name
          },
          p,
          isNaN(D.value.body[i] / l.total) ? "-" : C({
            v: D.value.body[i] / l.total * 100,
            s: "%",
            r: e.value.table.td.roundingPercentage
          })
        ];
      }), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: t,
        body: u,
        config: a
      };
    });
    function Ye() {
      return S.value;
    }
    function Se() {
      x.value.showTable = !x.value.showTable;
    }
    function Ne() {
      x.value.dataLabels.show = !x.value.dataLabels.show;
    }
    function Te() {
      x.value.showTooltip = !x.value.showTooltip;
    }
    return Oe({
      getData: Ye,
      generatePdf: ge,
      generateCsv: Ce,
      generateImage: me,
      toggleTable: Se,
      toggleLabels: Ne,
      toggleTooltip: Te
    }), (t, u) => (s(), n("div", {
      ref_key: "nestedDonutsChart",
      ref: B,
      class: P(`vue-ui-nested-donuts ${U.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: se(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${!e.value.style.chart.title.text && e.value.userOptions.show ? "padding-top:36px" : ""};background:${e.value.style.chart.backgroundColor}`),
      id: `nested_donuts_${g.value}`
    }, [
      e.value.style.chart.title.text ? (s(), n("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: de
      }, [
        (s(), O(vt, {
          key: `title_${ce.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && G.value ? (s(), O(ft, {
        ref: "details",
        key: `user_option_${ie.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: r(pe),
        isImaging: r(be),
        uid: g.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: U.value,
        isTooltip: x.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: B.value,
        onToggleFullscreen: Me,
        onGeneratePdf: r(ge),
        onGenerateCsv: Ce,
        onGenerateImage: r(me),
        onToggleTable: Se,
        onToggleLabels: Ne,
        onToggleTooltip: Te
      }, We({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: m(() => [
            $(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            $(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            $(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            $(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            $(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: m(() => [
            $(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: a, isFullscreen: o }) => [
            $(t.$slots, "optionFullscreen", q(J({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      G.value ? (s(), n("svg", {
        key: 2,
        xmlns: r(st),
        class: P({ "vue-data-ui-fullscreen--on": U.value, "vue-data-ui-fulscreen--off": !U.value }),
        viewBox: `0 0 ${v.value.width <= 0 ? 1e-3 : v.value.width} ${v.value.height < 0 ? 1e-3 : v.value.height}`,
        style: se(`max-width:100%; overflow: visible; background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        b("defs", null, [
          (s(!0), n(w, null, L(ke.value, (a, o) => (s(), n("radialGradient", {
            id: `radial_${g.value}_${o}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fr: 30 - 1 * (o + 1) + "%"
          }, [
            $t,
            b("stop", {
              offset: 70 - 20 * o + "%",
              "stop-color": "#FFFFFF",
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, Lt),
            Ct
          ], 8, kt))), 256))
        ]),
        b("defs", null, [
          b("filter", {
            id: `blur_${g.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            b("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${g.value}`
            }, null, 8, Nt),
            Tt
          ], 8, St),
          b("filter", {
            id: `shadow_${g.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            b("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, It)
          ], 8, Ft)
        ]),
        (s(!0), n(w, null, L(R.value, (a) => (s(), n("circle", {
          cx: v.value.width / 2,
          cy: v.value.height / 2,
          r: a.radius < 0 ? 1e-5 : a.radius,
          fill: e.value.style.chart.backgroundColor,
          filter: e.value.style.chart.layout.donut.useShadow ? `url(#shadow_${g.value})` : ""
        }, null, 8, Dt))), 256)),
        (s(!0), n(w, null, L(R.value, (a, o) => (s(), n("g", null, [
          (s(!0), n(w, null, L(a.donut, (l, i) => (s(), n("g", null, [
            b("path", {
              class: "vue-ui-donut-arc-path",
              d: l.arcSlice,
              fill: `${l.color}CC`,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: Le(l, i)
            }, null, 8, zt)
          ]))), 256))
        ]))), 256)),
        e.value.style.chart.useGradient ? (s(), n("g", Pt, [
          (s(!0), n(w, null, L(ke.value, (a, o) => (s(), n("g", null, [
            b("path", {
              d: a.donut.arcSlice,
              fill: `url(#radial_${g.value}_${o})`,
              stroke: "transparent",
              "stroke-width": "0"
            }, null, 8, Ot)
          ]))), 256))
        ])) : y("", !0),
        e.value.style.chart.layout.labels.dataLabels.showDonutName ? (s(), n("g", At, [
          (s(!0), n(w, null, L(R.value, (a, o) => (s(), n("g", null, [
            (s(!0), n(w, null, L(a.donut, (l, i) => (s(), n("g", null, [
              i === 0 && v.value.width && v.value.height ? (s(), n("text", {
                key: 0,
                class: P({ animated: e.value.useCssAnimation }),
                x: v.value.width / 2,
                y: l.startY - e.value.style.chart.layout.labels.dataLabels.fontSize + e.value.style.chart.layout.labels.dataLabels.donutNameOffsetY,
                "text-anchor": "middle",
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldDonutName ? "bold" : "normal",
                fill: e.value.style.chart.layout.labels.dataLabels.color
              }, F(e.value.style.chart.layout.labels.dataLabels.donutNameAbbreviation ? r(ut)({ source: a.name, length: e.value.style.chart.layout.labels.dataLabels.donutNameMaxAbbreviationSize }) : a.name), 11, Vt)) : y("", !0)
            ]))), 256))
          ]))), 256))
        ])) : y("", !0),
        e.value.style.chart.layout.labels.dataLabels.show ? (s(), n("g", Mt, [
          (s(!0), n(w, null, L(R.value, (a, o) => (s(), n("g", null, [
            (s(!0), n(w, null, L(a.donut, (l, i) => (s(), n("g", {
              filter: Le(l, i)
            }, [
              ae(l) && x.value.dataLabels.show && e.value.style.chart.layout.labels.dataLabels.showPercentage ? (s(), n("text", {
                key: 0,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(V)(l, !0).anchor,
                x: r(V)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ue)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY),
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldPercentage ? "bold" : "normal"
              }, F(r(C)({ v: l.proportion * 100, s: "%", r: e.value.style.chart.layout.labels.dataLabels.roundingPercentage })), 11, Ut)) : y("", !0),
              ae(l) && x.value.dataLabels.show && e.value.style.chart.layout.labels.dataLabels.showPercentage && e.value.style.chart.layout.labels.dataLabels.showValue ? (s(), n("text", {
                key: 1,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(V)(l, !0).anchor,
                x: r(V)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ue)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY) + e.value.style.chart.layout.labels.dataLabels.fontSize,
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldValue ? "bold" : "normal"
              }, " (" + F(r(E)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(C)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.dataLabels.roundingValue
                }),
                { datapoint: l, seriesIndex: o, datapointIndex: i }
              )) + ") ", 11, Rt)) : y("", !0),
              ae(l) && x.value.dataLabels.show && !e.value.style.chart.layout.labels.dataLabels.showPercentage && e.value.style.chart.layout.labels.dataLabels.showValue ? (s(), n("text", {
                key: 2,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(V)(l, !0).anchor,
                x: r(V)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ue)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY),
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldValue ? "bold" : "normal"
              }, F(r(E)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(C)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.dataLabels.roundingValue
                }),
                { datapoint: l, seriesIndex: o, datapointIndex: i }
              )), 11, Et)) : y("", !0)
            ], 8, Bt))), 256))
          ]))), 256))
        ])) : y("", !0),
        (s(!0), n(w, null, L(R.value, (a, o) => (s(), n("g", null, [
          (s(!0), n(w, null, L(a.donut, (l, i) => (s(), n("g", null, [
            b("path", {
              "data-cy-donut-trap": "",
              d: l.arcSlice,
              fill: Ve.value === o ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (p) => Ee({
                datapoint: l,
                relativeIndex: o,
                seriesIndex: l.seriesIndex
              }),
              onClick: (p) => Ue({ datapoint: l, index: i }),
              onMouseleave: u[0] || (u[0] = (p) => {
                Z.value = !1, $e.value = null, X.value = null, H.value = null;
              })
            }, null, 40, Gt)
          ]))), 256))
        ]))), 256)),
        $(t.$slots, "svg", { svg: v.value }, void 0, !0)
      ], 14, _t)) : y("", !0),
      t.$slots.watermark ? (s(), n("div", Yt, [
        $(t.$slots, "watermark", q(J({ isPrinting: r(pe) || r(be) })), void 0, !0)
      ])) : y("", !0),
      G.value ? y("", !0) : (s(), O(gt, {
        key: 4,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      qe(pt, {
        show: x.value.showTooltip && Z.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: B.value,
        content: j.value,
        isCustom: r(ze)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": m(() => [
          $(t.$slots, "tooltip-before", q(J({ ...le.value })), void 0, !0)
        ]),
        "tooltip-after": m(() => [
          $(t.$slots, "tooltip-after", q(J({ ...le.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      e.value.style.chart.legend.show ? (s(), n("div", {
        key: 5,
        ref_key: "chartLegend",
        ref: ee,
        class: P({ "vue-ui-nested-donuts-legend": oe.value.length > 1 })
      }, [
        (s(!0), n(w, null, L(oe.value, (a, o) => (s(), O(bt, {
          key: `legend_${o}_${he.value}`,
          legendSet: a,
          config: Ge.value,
          onClickMarker: u[1] || (u[1] = ({ legend: l }) => te(l))
        }, {
          legendTitle: m(({ titleSet: l }) => [
            l[0] && l[0].arcOf ? (s(), n("div", Xt, F(l[0].arcOf), 1)) : y("", !0)
          ]),
          item: m(({ legend: l, index: i }) => [
            b("div", {
              onClick: (p) => te(l),
              style: se(`opacity:${f.value.includes(l.id) ? 0.5 : 1}`)
            }, [
              K(F(l.name) + ": " + F(r(E)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(C)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: l, seriesIndex: i }
              )) + " ", 1),
              f.value.includes(l.id) ? (s(), n(w, { key: 1 }, [
                K(" ( - % ) ")
              ], 64)) : (s(), n(w, { key: 0 }, [
                K(" (" + F(isNaN(l.value / l.total) ? "-" : r(C)({ v: l.value / l.total * 100, s: "%", r: e.value.style.chart.legend.roundingPercentage })) + ") ", 1)
              ], 64))
            ], 12, Ht)
          ]),
          _: 2
        }, 1032, ["legendSet", "config"]))), 128))
      ], 2)) : y("", !0),
      e.value.style.chart.legend.show ? y("", !0) : (s(), n("div", {
        key: 6,
        ref_key: "chartLegend",
        ref: ee
      }, [
        $(t.$slots, "legend", { legend: oe.value }, void 0, !0)
      ], 512)),
      G.value ? (s(), O(mt, {
        key: 7,
        hideDetails: "",
        config: {
          open: x.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (s(), O(yt, {
            key: `table_${ve.value}`,
            colNames: W.value.colNames,
            head: W.value.head,
            body: W.value.body,
            config: W.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: u[2] || (u[2] = (a) => x.value.showTable = !1)
          }, {
            th: m(({ th: a }) => [
              b("div", {
                innerHTML: a,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Wt)
            ]),
            td: m(({ td: a }) => [
              K(F(a.name || a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 14, xt));
  }
}, nl = /* @__PURE__ */ wt(qt, [["__scopeId", "data-v-7e1c384d"]]);
export {
  nl as default
};
